/* icon-factory.c generated by valac 0.41.91, the Vala compiler
 * generated from icon-factory.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Singleton class to hold icons.*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>


#define TYPE_ICON_FACTORY (icon_factory_get_type ())
#define ICON_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_FACTORY, IconFactory))
#define ICON_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_FACTORY, IconFactoryClass))
#define IS_ICON_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_FACTORY))
#define IS_ICON_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_FACTORY))
#define ICON_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_FACTORY, IconFactoryClass))

typedef struct _IconFactory IconFactory;
typedef struct _IconFactoryClass IconFactoryClass;
typedef struct _IconFactoryPrivate IconFactoryPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))
#define _icon_factory_unref0(var) ((var == NULL) ? NULL : (var = (icon_factory_unref (var), NULL)))
typedef struct _ParamSpecIconFactory ParamSpecIconFactory;

struct _IconFactory {
	GTypeInstance parent_instance;
	volatile int ref_count;
	IconFactoryPrivate * priv;
};

struct _IconFactoryClass {
	GTypeClass parent_class;
	void (*finalize) (IconFactory *self);
};

struct _IconFactoryPrivate {
	GtkIconTheme* _icon_theme;
	GFile* icons_dir;
};

struct _ParamSpecIconFactory {
	GParamSpec parent_instance;
};


static gint IconFactory_private_offset;
static gpointer icon_factory_parent_class = NULL;
static IconFactory* icon_factory__instance;
static IconFactory* icon_factory__instance = NULL;

gpointer icon_factory_ref (gpointer instance);
void icon_factory_unref (gpointer instance);
GParamSpec* param_spec_icon_factory (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
void value_set_icon_factory (GValue* value,
                             gpointer v_object);
void value_take_icon_factory (GValue* value,
                              gpointer v_object);
gpointer value_get_icon_factory (const GValue* value);
GType icon_factory_get_type (void) G_GNUC_CONST;
#define ICON_FACTORY_ICON_TOOLBAR GTK_ICON_SIZE_LARGE_TOOLBAR
#define ICON_FACTORY_ICON_SIDEBAR GTK_ICON_SIZE_MENU
#define ICON_FACTORY_UNREAD_ICON_SIZE 16
#define ICON_FACTORY_STAR_ICON_SIZE 16
static IconFactory* icon_factory_new (void);
static IconFactory* icon_factory_construct (GType object_type);
GType geary_application_get_type (void) G_GNUC_CONST;
GearyApplication* geary_application_get_instance (void) G_GNUC_DEPRECATED;
GFile* geary_application_get_resource_directory (GearyApplication* self);
static void icon_factory_set_icon_theme (IconFactory* self,
                                  GtkIconTheme* value);
static GtkIconTheme* icon_factory_get_icon_theme (IconFactory* self);
void icon_factory_init (IconFactory* self);
static gint icon_factory_icon_size_to_pixels (IconFactory* self,
                                       GtkIconSize icon_size);
GIcon* icon_factory_get_theme_icon (IconFactory* self,
                                    const gchar* name);
GIcon* icon_factory_get_custom_icon (IconFactory* self,
                                     const gchar* name,
                                     GtkIconSize size);
static GdkPixbuf* icon_factory_get_missing_icon (IconFactory* self,
                                          gint size,
                                          GtkIconLookupFlags flags);
GtkIconInfo* icon_factory_lookup_icon (IconFactory* self,
                                       const gchar* icon_name,
                                       gint size,
                                       GtkIconLookupFlags flags);
static GdkPixbuf* icon_factory_aspect_scale_down_pixbuf (IconFactory* self,
                                                  GdkPixbuf* pixbuf,
                                                  gint size);
GdkPixbuf* icon_factory_load_symbolic (IconFactory* self,
                                       const gchar* icon_name,
                                       gint size,
                                       GtkStyleContext* style,
                                       GtkIconLookupFlags flags);
GdkPixbuf* icon_factory_load_symbolic_colored (IconFactory* self,
                                               const gchar* icon_name,
                                               gint size,
                                               GdkRGBA* color,
                                               GtkIconLookupFlags flags);
IconFactory* icon_factory_get_instance (void);
static void icon_factory_set_instance (IconFactory* value);
static void icon_factory_finalize (IconFactory * obj);


static inline gpointer
icon_factory_get_instance_private (IconFactory* self)
{
	return G_STRUCT_MEMBER_P (self, IconFactory_private_offset);
}


static IconFactory*
icon_factory_construct (GType object_type)
{
	IconFactory* self = NULL;
	GearyApplication* _tmp0_;
	GearyApplication* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GtkIconTheme* _tmp5_;
	GtkIconTheme* _tmp6_;
	GFile* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 32 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	self = (IconFactory*) g_type_create_instance (object_type);
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp0_ = geary_application_get_instance ();
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp1_ = _tmp0_;
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp2_ = geary_application_get_resource_directory (_tmp1_);
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp3_ = _tmp2_;
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp4_ = g_file_get_child (_tmp3_, "icons");
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_g_object_unref0 (self->priv->icons_dir);
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	self->priv->icons_dir = _tmp4_;
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_g_object_unref0 (_tmp3_);
#line 34 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp5_ = gtk_icon_theme_get_default ();
#line 34 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	icon_factory_set_icon_theme (self, _tmp5_);
#line 35 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp6_ = self->priv->_icon_theme;
#line 35 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp7_ = self->priv->icons_dir;
#line 35 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp8_ = g_file_get_path (_tmp7_);
#line 35 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp9_ = _tmp8_;
#line 35 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	gtk_icon_theme_append_search_path (_tmp6_, _tmp9_);
#line 35 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_g_free0 (_tmp9_);
#line 32 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return self;
#line 194 "icon-factory.c"
}


static IconFactory*
icon_factory_new (void)
{
#line 32 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return icon_factory_construct (TYPE_ICON_FACTORY);
#line 203 "icon-factory.c"
}


void
icon_factory_init (IconFactory* self)
{
#line 38 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 212 "icon-factory.c"
}


static gint
icon_factory_icon_size_to_pixels (IconFactory* self,
                                  GtkIconSize icon_size)
{
	gint result = 0;
#line 43 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), 0);
#line 44 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	switch (icon_size) {
#line 44 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		case ICON_FACTORY_ICON_SIDEBAR:
#line 227 "icon-factory.c"
		{
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			result = 16;
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			return result;
#line 233 "icon-factory.c"
		}
		default:
#line 44 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		case ICON_FACTORY_ICON_TOOLBAR:
#line 238 "icon-factory.c"
		{
#line 50 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			result = 24;
#line 50 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			return result;
#line 244 "icon-factory.c"
		}
	}
}


GIcon*
icon_factory_get_theme_icon (IconFactory* self,
                             const gchar* name)
{
	GIcon* result = NULL;
	GThemedIcon* _tmp0_;
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new (name);
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_icon_get_type (), GIcon);
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return result;
#line 266 "icon-factory.c"
}


GIcon*
icon_factory_get_custom_icon (IconFactory* self,
                              const gchar* name,
                              GtkIconSize size)
{
	GIcon* result = NULL;
	gint pixels = 0;
	GFile* icon_file = NULL;
	GFile* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp16_;
	GFileIcon* _tmp17_;
#line 58 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 58 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	pixels = icon_factory_icon_size_to_pixels (self, size);
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->icons_dir;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp1_ = pixels;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp2_ = pixels;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp3_ = g_strdup_printf ("%dx%d", _tmp1_, _tmp2_);
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp4_ = _tmp3_;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp5_ = g_file_get_child (_tmp0_, _tmp4_);
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp6_ = _tmp5_;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp7_ = g_strdup_printf ("%s.svg", name);
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp8_ = _tmp7_;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp9_ = g_file_get_child (_tmp6_, _tmp8_);
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp10_ = _tmp9_;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_g_free0 (_tmp8_);
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_g_object_unref0 (_tmp6_);
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_g_free0 (_tmp4_);
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	icon_file = _tmp10_;
#line 66 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp11_ = icon_file;
#line 66 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (!g_file_query_exists (_tmp11_, NULL)) {
#line 332 "icon-factory.c"
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GFile* _tmp15_;
#line 67 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp12_ = self->priv->icons_dir;
#line 67 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp13_ = g_strdup_printf ("%s.svg", name);
#line 67 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp14_ = _tmp13_;
#line 67 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp15_ = g_file_get_child (_tmp12_, _tmp14_);
#line 67 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_g_object_unref0 (icon_file);
#line 67 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		icon_file = _tmp15_;
#line 67 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_g_free0 (_tmp14_);
#line 351 "icon-factory.c"
	}
#line 69 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp16_ = icon_file;
#line 69 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp17_ = (GFileIcon*) g_file_icon_new (_tmp16_);
#line 69 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, g_icon_get_type (), GIcon);
#line 69 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_g_object_unref0 (icon_file);
#line 69 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return result;
#line 363 "icon-factory.c"
}


static GdkPixbuf*
icon_factory_get_missing_icon (IconFactory* self,
                               gint size,
                               GtkIconLookupFlags flags)
{
	GdkPixbuf* result = NULL;
	GError * _inner_error_ = NULL;
#line 73 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 376 "icon-factory.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		GtkIconTheme* _tmp1_;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp1_ = self->priv->_icon_theme;
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp2_ = gtk_icon_theme_load_icon (_tmp1_, "image-missing", size, flags, &_inner_error_);
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp0_ = _tmp2_;
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 390 "icon-factory.c"
			goto __catch66_g_error;
		}
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp3_ = _tmp0_;
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp0_ = NULL;
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		result = _tmp3_;
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_g_object_unref0 (_tmp0_);
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		return result;
#line 403 "icon-factory.c"
	}
	goto __finally66;
	__catch66_g_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 74 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		err = _inner_error_;
#line 74 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_inner_error_ = NULL;
#line 77 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp4_ = err;
#line 77 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp5_ = _tmp4_->message;
#line 77 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		g_warning ("icon-factory.vala:77: Couldn't load image-missing icon: %s", _tmp5_);
#line 74 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_g_error_free0 (err);
#line 423 "icon-factory.c"
	}
	__finally66:
#line 74 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 74 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 74 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		g_clear_error (&_inner_error_);
#line 74 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		return NULL;
#line 434 "icon-factory.c"
	}
#line 81 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	result = NULL;
#line 81 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return result;
#line 440 "icon-factory.c"
}


GtkIconInfo*
icon_factory_lookup_icon (IconFactory* self,
                          const gchar* icon_name,
                          gint size,
                          GtkIconLookupFlags flags)
{
	GtkIconInfo* result = NULL;
	GtkIconInfo* icon_info = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconInfo* _tmp1_;
	GtkIconInfo* _tmp2_ = NULL;
	GtkIconInfo* _tmp3_;
#line 84 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 84 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 85 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 85 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp1_ = gtk_icon_theme_lookup_icon (_tmp0_, icon_name, size, flags);
#line 85 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	icon_info = _tmp1_;
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp3_ = icon_info;
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (_tmp3_ != NULL) {
#line 470 "icon-factory.c"
		GtkIconInfo* _tmp4_;
		GtkIconInfo* _tmp5_;
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp4_ = icon_info;
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp5_ = gtk_icon_info_copy (_tmp4_);
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_gtk_icon_info_free0 (_tmp2_);
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp2_ = _tmp5_;
#line 481 "icon-factory.c"
	} else {
		GtkIconTheme* _tmp6_;
		GtkIconInfo* _tmp7_;
#line 87 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp6_ = self->priv->_icon_theme;
#line 87 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp7_ = gtk_icon_theme_lookup_icon (_tmp6_, "text-x-generic-symbolic", size, flags);
#line 87 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_gtk_icon_info_free0 (_tmp2_);
#line 87 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp2_ = _tmp7_;
#line 493 "icon-factory.c"
	}
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	result = _tmp2_;
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_gtk_icon_info_free0 (icon_info);
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return result;
#line 501 "icon-factory.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 94 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return self ? g_object_ref (self) : NULL;
#line 510 "icon-factory.c"
}


static GdkPixbuf*
icon_factory_aspect_scale_down_pixbuf (IconFactory* self,
                                       GdkPixbuf* pixbuf,
                                       gint size)
{
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gint scaled_width = 0;
	gint scaled_height = 0;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp20_;
	gint _tmp21_;
	GdkPixbuf* _tmp22_;
#line 92 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 92 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 93 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp1_ = gdk_pixbuf_get_width (pixbuf);
#line 93 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp2_ = _tmp1_;
#line 93 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (_tmp2_ <= size) {
#line 542 "icon-factory.c"
		gint _tmp3_;
		gint _tmp4_;
#line 93 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp3_ = gdk_pixbuf_get_height (pixbuf);
#line 93 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp4_ = _tmp3_;
#line 93 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp0_ = _tmp4_ <= size;
#line 551 "icon-factory.c"
	} else {
#line 93 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp0_ = FALSE;
#line 555 "icon-factory.c"
	}
#line 93 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (_tmp0_) {
#line 559 "icon-factory.c"
		GdkPixbuf* _tmp5_;
#line 94 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp5_ = _g_object_ref0 (pixbuf);
#line 94 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		result = _tmp5_;
#line 94 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		return result;
#line 567 "icon-factory.c"
	}
#line 97 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp6_ = gdk_pixbuf_get_width (pixbuf);
#line 97 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp7_ = _tmp6_;
#line 97 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp8_ = gdk_pixbuf_get_height (pixbuf);
#line 97 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp9_ = _tmp8_;
#line 97 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (_tmp7_ >= _tmp9_) {
#line 579 "icon-factory.c"
		gdouble aspect = 0.0;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gdouble _tmp14_;
#line 98 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp10_ = gdk_pixbuf_get_width (pixbuf);
#line 98 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp11_ = _tmp10_;
#line 98 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		aspect = ((gdouble) size) / ((gdouble) _tmp11_);
#line 99 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		scaled_width = size;
#line 100 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp12_ = gdk_pixbuf_get_height (pixbuf);
#line 100 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp13_ = _tmp12_;
#line 100 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp14_ = aspect;
#line 100 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		scaled_height = (gint) round (((gdouble) _tmp13_) * _tmp14_);
#line 602 "icon-factory.c"
	} else {
		gdouble aspect = 0.0;
		gint _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gdouble _tmp19_;
#line 102 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp15_ = gdk_pixbuf_get_height (pixbuf);
#line 102 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp16_ = _tmp15_;
#line 102 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		aspect = ((gdouble) size) / ((gdouble) _tmp16_);
#line 103 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp17_ = gdk_pixbuf_get_width (pixbuf);
#line 103 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp18_ = _tmp17_;
#line 103 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp19_ = aspect;
#line 103 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		scaled_width = (gint) round (((gdouble) _tmp18_) * _tmp19_);
#line 104 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		scaled_height = size;
#line 626 "icon-factory.c"
	}
#line 107 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp20_ = scaled_width;
#line 107 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp21_ = scaled_height;
#line 107 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp22_ = gdk_pixbuf_scale_simple (pixbuf, _tmp20_, _tmp21_, GDK_INTERP_BILINEAR);
#line 107 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	result = _tmp22_;
#line 107 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return result;
#line 638 "icon-factory.c"
}


GdkPixbuf*
icon_factory_load_symbolic (IconFactory* self,
                            const gchar* icon_name,
                            gint size,
                            GtkStyleContext* style,
                            GtkIconLookupFlags flags)
{
	GdkPixbuf* result = NULL;
	GtkIconInfo* icon_info = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconInfo* _tmp1_;
	GtkIconInfo* _tmp2_;
	GdkPixbuf* _tmp9_;
	GError * _inner_error_ = NULL;
#line 110 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 110 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 110 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (GTK_IS_STYLE_CONTEXT (style), NULL);
#line 112 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 112 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp1_ = gtk_icon_theme_lookup_icon (_tmp0_, icon_name, size, flags);
#line 112 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	icon_info = _tmp1_;
#line 115 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp2_ = icon_info;
#line 115 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (_tmp2_ != NULL) {
#line 672 "icon-factory.c"
		{
			GdkPixbuf* _tmp3_ = NULL;
			GtkIconInfo* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 117 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp4_ = icon_info;
#line 117 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp5_ = gtk_icon_info_load_symbolic_for_context (_tmp4_, style, NULL, &_inner_error_);
#line 117 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp3_ = _tmp5_;
#line 117 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 686 "icon-factory.c"
				goto __catch67_g_error;
			}
#line 117 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp6_ = icon_factory_aspect_scale_down_pixbuf (self, _tmp3_, size);
#line 117 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			result = _tmp6_;
#line 117 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_g_object_unref0 (_tmp3_);
#line 117 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_gtk_icon_info_free0 (icon_info);
#line 117 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			return result;
#line 699 "icon-factory.c"
		}
		goto __finally67;
		__catch67_g_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
#line 116 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			e = _inner_error_;
#line 116 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_inner_error_ = NULL;
#line 119 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp7_ = e;
#line 119 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp8_ = _tmp7_->message;
#line 119 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			g_message ("icon-factory.vala:119: Couldn't load icon: %s", _tmp8_);
#line 116 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_g_error_free0 (e);
#line 719 "icon-factory.c"
		}
		__finally67:
#line 116 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 116 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_gtk_icon_info_free0 (icon_info);
#line 116 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 116 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			g_clear_error (&_inner_error_);
#line 116 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			return NULL;
#line 732 "icon-factory.c"
		}
	}
#line 124 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp9_ = icon_factory_get_missing_icon (self, size, flags);
#line 124 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	result = _tmp9_;
#line 124 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_gtk_icon_info_free0 (icon_info);
#line 124 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return result;
#line 743 "icon-factory.c"
}


/**
     * Loads a symbolic icon into a pixbuf, where the color-key has been switched to the provided
     * color.
     */
GdkPixbuf*
icon_factory_load_symbolic_colored (IconFactory* self,
                                    const gchar* icon_name,
                                    gint size,
                                    GdkRGBA* color,
                                    GtkIconLookupFlags flags)
{
	GdkPixbuf* result = NULL;
	GtkIconInfo* icon_info = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconInfo* _tmp1_;
	GtkIconInfo* _tmp2_;
	GdkPixbuf* _tmp10_;
	GError * _inner_error_ = NULL;
#line 131 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 131 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 131 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 133 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 133 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp1_ = gtk_icon_theme_lookup_icon (_tmp0_, icon_name, size, flags);
#line 133 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	icon_info = _tmp1_;
#line 136 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp2_ = icon_info;
#line 136 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (_tmp2_ != NULL) {
#line 781 "icon-factory.c"
		{
			GdkPixbuf* _tmp3_ = NULL;
			GtkIconInfo* _tmp4_;
			GdkRGBA _tmp5_;
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
#line 138 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp4_ = icon_info;
#line 138 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp5_ = *color;
#line 138 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp6_ = gtk_icon_info_load_symbolic (_tmp4_, &_tmp5_, NULL, NULL, NULL, NULL, &_inner_error_);
#line 138 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp3_ = _tmp6_;
#line 138 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 798 "icon-factory.c"
				goto __catch68_g_error;
			}
#line 138 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp7_ = icon_factory_aspect_scale_down_pixbuf (self, _tmp3_, size);
#line 138 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			result = _tmp7_;
#line 138 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_g_object_unref0 (_tmp3_);
#line 138 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_gtk_icon_info_free0 (icon_info);
#line 138 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			return result;
#line 811 "icon-factory.c"
		}
		goto __finally68;
		__catch68_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 137 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			e = _inner_error_;
#line 137 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_inner_error_ = NULL;
#line 140 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp8_ = e;
#line 140 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_tmp9_ = _tmp8_->message;
#line 140 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			g_warning ("icon-factory.vala:140: Couldn't load icon: %s", _tmp9_);
#line 137 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_g_error_free0 (e);
#line 831 "icon-factory.c"
		}
		__finally68:
#line 137 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 137 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			_gtk_icon_info_free0 (icon_info);
#line 137 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 137 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			g_clear_error (&_inner_error_);
#line 137 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			return NULL;
#line 844 "icon-factory.c"
		}
	}
#line 144 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp10_ = icon_factory_get_missing_icon (self, size, flags);
#line 144 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	result = _tmp10_;
#line 144 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_gtk_icon_info_free0 (icon_info);
#line 144 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return result;
#line 855 "icon-factory.c"
}


IconFactory*
icon_factory_get_instance (void)
{
	IconFactory* result;
	IconFactory* _tmp0_;
	IconFactory* _tmp2_;
#line 15 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp0_ = icon_factory__instance;
#line 15 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (_tmp0_ == NULL) {
#line 869 "icon-factory.c"
		IconFactory* _tmp1_;
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_tmp1_ = icon_factory_new ();
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		_icon_factory_unref0 (icon_factory__instance);
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		icon_factory__instance = _tmp1_;
#line 877 "icon-factory.c"
	}
#line 18 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp2_ = icon_factory__instance;
#line 18 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	result = _tmp2_;
#line 18 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return result;
#line 885 "icon-factory.c"
}


static gpointer
_icon_factory_ref0 (gpointer self)
{
#line 21 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return self ? icon_factory_ref (self) : NULL;
#line 894 "icon-factory.c"
}


static void
icon_factory_set_instance (IconFactory* value)
{
	IconFactory* _tmp0_;
#line 21 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp0_ = _icon_factory_ref0 (value);
#line 21 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_icon_factory_unref0 (icon_factory__instance);
#line 21 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	icon_factory__instance = _tmp0_;
#line 908 "icon-factory.c"
}


static GtkIconTheme*
icon_factory_get_icon_theme (IconFactory* self)
{
	GtkIconTheme* result;
	GtkIconTheme* _tmp0_;
#line 27 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 27 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 27 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	result = _tmp0_;
#line 27 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return result;
#line 925 "icon-factory.c"
}


static void
icon_factory_set_icon_theme (IconFactory* self,
                             GtkIconTheme* value)
{
	GtkIconTheme* _tmp0_;
#line 27 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 27 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 27 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_g_object_unref0 (self->priv->_icon_theme);
#line 27 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	self->priv->_icon_theme = _tmp0_;
#line 942 "icon-factory.c"
}


static void
value_icon_factory_init (GValue* value)
{
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	value->data[0].v_pointer = NULL;
#line 951 "icon-factory.c"
}


static void
value_icon_factory_free_value (GValue* value)
{
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (value->data[0].v_pointer) {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		icon_factory_unref (value->data[0].v_pointer);
#line 962 "icon-factory.c"
	}
}


static void
value_icon_factory_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (src_value->data[0].v_pointer) {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		dest_value->data[0].v_pointer = icon_factory_ref (src_value->data[0].v_pointer);
#line 975 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		dest_value->data[0].v_pointer = NULL;
#line 979 "icon-factory.c"
	}
}


static gpointer
value_icon_factory_peek_pointer (const GValue* value)
{
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return value->data[0].v_pointer;
#line 989 "icon-factory.c"
}


static gchar*
value_icon_factory_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (collect_values[0].v_pointer) {
#line 1001 "icon-factory.c"
		IconFactory * object;
		object = collect_values[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		if (object->parent_instance.g_class == NULL) {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1008 "icon-factory.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1012 "icon-factory.c"
		}
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		value->data[0].v_pointer = icon_factory_ref (object);
#line 1016 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		value->data[0].v_pointer = NULL;
#line 1020 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return NULL;
#line 1024 "icon-factory.c"
}


static gchar*
value_icon_factory_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	IconFactory ** object_p;
	object_p = collect_values[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (!object_p) {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1040 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (!value->data[0].v_pointer) {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		*object_p = NULL;
#line 1046 "icon-factory.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		*object_p = value->data[0].v_pointer;
#line 1050 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		*object_p = icon_factory_ref (value->data[0].v_pointer);
#line 1054 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return NULL;
#line 1058 "icon-factory.c"
}


GParamSpec*
param_spec_icon_factory (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecIconFactory* spec;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ICON_FACTORY), NULL);
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return G_PARAM_SPEC (spec);
#line 1078 "icon-factory.c"
}


gpointer
value_get_icon_factory (const GValue* value)
{
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_FACTORY), NULL);
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return value->data[0].v_pointer;
#line 1089 "icon-factory.c"
}


void
value_set_icon_factory (GValue* value,
                        gpointer v_object)
{
	IconFactory * old;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_FACTORY));
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	old = value->data[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (v_object) {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ICON_FACTORY));
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		value->data[0].v_pointer = v_object;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		icon_factory_ref (value->data[0].v_pointer);
#line 1112 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		value->data[0].v_pointer = NULL;
#line 1116 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (old) {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		icon_factory_unref (old);
#line 1122 "icon-factory.c"
	}
}


void
value_take_icon_factory (GValue* value,
                         gpointer v_object)
{
	IconFactory * old;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_FACTORY));
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	old = value->data[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (v_object) {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ICON_FACTORY));
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		value->data[0].v_pointer = v_object;
#line 1144 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		value->data[0].v_pointer = NULL;
#line 1148 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (old) {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		icon_factory_unref (old);
#line 1154 "icon-factory.c"
	}
}


static void
icon_factory_class_init (IconFactoryClass * klass)
{
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	icon_factory_parent_class = g_type_class_peek_parent (klass);
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	((IconFactoryClass *) klass)->finalize = icon_factory_finalize;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_type_class_adjust_private_offset (klass, &IconFactory_private_offset);
#line 1168 "icon-factory.c"
}


static void
icon_factory_instance_init (IconFactory * self)
{
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	self->priv = icon_factory_get_instance_private (self);
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	self->ref_count = 1;
#line 1179 "icon-factory.c"
}


static void
icon_factory_finalize (IconFactory * obj)
{
	IconFactory * self;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_FACTORY, IconFactory);
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_signal_handlers_destroy (self);
#line 27 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_g_object_unref0 (self->priv->_icon_theme);
#line 29 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	_g_object_unref0 (self->priv->icons_dir);
#line 1195 "icon-factory.c"
}


GType
icon_factory_get_type (void)
{
	static volatile gsize icon_factory_type_id__volatile = 0;
	if (g_once_init_enter (&icon_factory_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_icon_factory_init, value_icon_factory_free_value, value_icon_factory_copy_value, value_icon_factory_peek_pointer, "p", value_icon_factory_collect_value, "p", value_icon_factory_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (IconFactoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_factory_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconFactory), 0, (GInstanceInitFunc) icon_factory_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType icon_factory_type_id;
		icon_factory_type_id = g_type_register_fundamental (g_type_fundamental_next (), "IconFactory", &g_define_type_info, &g_define_type_fundamental_info, 0);
		IconFactory_private_offset = g_type_add_instance_private (icon_factory_type_id, sizeof (IconFactoryPrivate));
		g_once_init_leave (&icon_factory_type_id__volatile, icon_factory_type_id);
	}
	return icon_factory_type_id__volatile;
}


gpointer
icon_factory_ref (gpointer instance)
{
	IconFactory * self;
	self = instance;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	g_atomic_int_inc (&self->ref_count);
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	return instance;
#line 1225 "icon-factory.c"
}


void
icon_factory_unref (gpointer instance)
{
	IconFactory * self;
	self = instance;
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		ICON_FACTORY_GET_CLASS (self)->finalize (self);
#line 8 "/builddir/build/BUILD/geary-0.12.4/src/client/components/icon-factory.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1240 "icon-factory.c"
	}
}



