/* util-ascii.c generated by valac 0.41.91, the Vala compiler
 * generated from util-ascii.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* These calls are bound to the string class in Vala 0.26.  When that version of Vala is the*/
/* minimum, these can be dropped and Ascii.strup and Ascii.strdown can use the string methods.*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


typedef guint8 (*GearyCollectionByteTransformer) (guint8 b, gpointer user_data);


gchar* g_ascii_strup (const gchar* str,
                      gssize len);
gchar* g_ascii_strdown (const gchar* str,
                        gssize len);
gint geary_ascii_index_of (const gchar* str,
                           gchar ch);
#define GEARY_STRING_EOS '\0'
gboolean geary_ascii_get_next_char (const gchar* str,
                                    gint* index,
                                    gchar* ch);
gint geary_ascii_strcmp (const gchar* a,
                         const gchar* b);
gint geary_ascii_stricmp (const gchar* a,
                          const gchar* b);
gboolean geary_ascii_str_equal (const gchar* a,
                                const gchar* b);
gboolean geary_ascii_stri_equal (const gchar* a,
                                 const gchar* b);
gboolean geary_ascii_nullable_stri_equal (const gchar* a,
                                          const gchar* b);
guint geary_ascii_str_hash (const gchar* str);
guint geary_collection_hash_memory_stream (void* ptr,
                                           guint8 terminator,
                                           GearyCollectionByteTransformer cb,
                                           gpointer cb_target);
guint geary_ascii_stri_hash (const gchar* str);
static guint8 __lambda12_ (guint8 b);
static guint8 ___lambda12__geary_collection_byte_transformer (guint8 b,
                                                       gpointer self);
guint geary_ascii_nullable_stri_hash (const gchar* str);
gchar* geary_ascii_strdown (const gchar* str);
gchar* geary_ascii_strup (const gchar* str);
gboolean geary_ascii_is_numeric (const gchar* str);
gint geary_ascii_digit_to_int (gchar ch);


gint
geary_ascii_index_of (const gchar* str,
                      gchar ch)
{
	gint result = 0;
	gchar* strptr = NULL;
	gint index = 0;
#line 14 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 15 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	strptr = str;
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	index = 0;
#line 72 "util-ascii.c"
	{
		gboolean _tmp0_ = FALSE;
#line 17 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		_tmp0_ = TRUE;
#line 17 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		while (TRUE) {
#line 79 "util-ascii.c"
			gchar strch = '\0';
			gchar* _tmp1_;
			gchar _tmp2_;
			gchar _tmp3_;
			gint _tmp4_;
#line 17 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			if (!_tmp0_) {
#line 87 "util-ascii.c"
			}
#line 17 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp0_ = FALSE;
#line 18 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp1_ = strptr;
#line 18 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			strptr = _tmp1_ + 1;
#line 18 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			strch = *_tmp1_;
#line 20 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp2_ = strch;
#line 20 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			if (_tmp2_ == GEARY_STRING_EOS) {
#line 21 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
				result = -1;
#line 21 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
				return result;
#line 105 "util-ascii.c"
			}
#line 23 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp3_ = strch;
#line 23 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			if (_tmp3_ == ch) {
#line 24 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
				result = index;
#line 24 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
				return result;
#line 115 "util-ascii.c"
			}
#line 26 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp4_ = index;
#line 26 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			index = _tmp4_ + 1;
#line 121 "util-ascii.c"
		}
	}
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1162 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1162 "glib-2.0.vapi"
	result = _tmp0_;
#line 1162 "glib-2.0.vapi"
	return result;
#line 141 "util-ascii.c"
}


gboolean
geary_ascii_get_next_char (const gchar* str,
                           gint* index,
                           gchar* ch)
{
	gchar _vala_ch = '\0';
	gboolean result = FALSE;
	gint _tmp0_;
#line 30 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (str != NULL, FALSE);
#line 31 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	_tmp0_ = *index;
#line 31 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	*index = _tmp0_ + 1;
#line 31 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	_vala_ch = string_get (str, (glong) _tmp0_);
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = _vala_ch != GEARY_STRING_EOS;
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	if (ch) {
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		*ch = _vala_ch;
#line 167 "util-ascii.c"
	}
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 171 "util-ascii.c"
}


inline gint
geary_ascii_strcmp (const gchar* a,
                    const gchar* b)
{
	gint result = 0;
	GCompareFunc _tmp0_;
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 37 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	_tmp0_ = g_strcmp0;
#line 37 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = _tmp0_ (a, b);
#line 37 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 191 "util-ascii.c"
}


gint
geary_ascii_stricmp (const gchar* a,
                     const gchar* b)
{
	gint result = 0;
	gchar* aptr = NULL;
	gchar* bptr = NULL;
#line 40 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 40 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 41 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	aptr = a;
#line 42 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	bptr = b;
#line 210 "util-ascii.c"
	{
		gboolean _tmp0_ = FALSE;
#line 43 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		_tmp0_ = TRUE;
#line 43 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		while (TRUE) {
#line 217 "util-ascii.c"
			gint diff = 0;
			gchar* _tmp1_;
			gchar* _tmp2_;
			gint _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 43 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			if (!_tmp0_) {
#line 227 "util-ascii.c"
			}
#line 43 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp0_ = FALSE;
#line 44 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp1_ = aptr;
#line 44 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp2_ = bptr;
#line 44 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			diff = ((gint) g_ascii_tolower (*_tmp1_)) - ((gint) g_ascii_tolower (*_tmp2_));
#line 45 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp3_ = diff;
#line 45 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			if (_tmp3_ != 0) {
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
				result = diff;
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
				return result;
#line 245 "util-ascii.c"
			}
#line 48 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp4_ = aptr;
#line 48 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			if ((*_tmp4_) == GEARY_STRING_EOS) {
#line 49 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
				result = 0;
#line 49 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
				return result;
#line 255 "util-ascii.c"
			}
#line 51 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp5_ = aptr;
#line 51 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			aptr = _tmp5_ + 1;
#line 52 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp6_ = bptr;
#line 52 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			bptr = _tmp6_ + 1;
#line 265 "util-ascii.c"
		}
	}
}


inline gboolean
geary_ascii_str_equal (const gchar* a,
                       const gchar* b)
{
	gboolean result = FALSE;
#line 56 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 56 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 57 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = g_strcmp0 (a, b) == 0;
#line 57 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 284 "util-ascii.c"
}


inline gboolean
geary_ascii_stri_equal (const gchar* a,
                        const gchar* b)
{
	gboolean result = FALSE;
#line 60 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 60 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 61 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = geary_ascii_stricmp (a, b) == 0;
#line 61 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 301 "util-ascii.c"
}


gboolean
geary_ascii_nullable_stri_equal (const gchar* a,
                                 const gchar* b)
{
	gboolean result = FALSE;
#line 65 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	if (a == NULL) {
#line 66 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		result = b == NULL;
#line 66 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		return result;
#line 316 "util-ascii.c"
	}
#line 69 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	if (b == NULL) {
#line 70 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		result = FALSE;
#line 70 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		return result;
#line 324 "util-ascii.c"
	}
#line 72 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = geary_ascii_stri_equal (a, b);
#line 72 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 330 "util-ascii.c"
}


guint
geary_ascii_str_hash (const gchar* str)
{
	guint result = 0U;
#line 75 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (str != NULL, 0U);
#line 76 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = geary_collection_hash_memory_stream ((gchar*) str, (guint8) GEARY_STRING_EOS, NULL, NULL);
#line 76 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 344 "util-ascii.c"
}


static guint8
__lambda12_ (guint8 b)
{
	guint8 result = 0U;
#line 81 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = (guint8) g_ascii_tolower ((gchar) b);
#line 81 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 356 "util-ascii.c"
}


static guint8
___lambda12__geary_collection_byte_transformer (guint8 b,
                                                gpointer self)
{
	guint8 result;
	result = __lambda12_ (b);
#line 80 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 368 "util-ascii.c"
}


guint
geary_ascii_stri_hash (const gchar* str)
{
	guint result = 0U;
#line 79 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (str != NULL, 0U);
#line 80 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = geary_collection_hash_memory_stream ((gchar*) str, (guint8) GEARY_STRING_EOS, ___lambda12__geary_collection_byte_transformer, NULL);
#line 80 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 382 "util-ascii.c"
}


guint
geary_ascii_nullable_stri_hash (const gchar* str)
{
	guint result = 0U;
	guint _tmp0_ = 0U;
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	if (str != NULL) {
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		_tmp0_ = geary_ascii_stri_hash (str);
#line 395 "util-ascii.c"
	} else {
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		_tmp0_ = (guint) 0;
#line 399 "util-ascii.c"
	}
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = _tmp0_;
#line 86 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 405 "util-ascii.c"
}


gchar*
geary_ascii_strdown (const gchar* str)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 89 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 90 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	_tmp0_ = g_ascii_strdown (str, (gssize) -1);
#line 90 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = _tmp0_;
#line 90 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 422 "util-ascii.c"
}


gchar*
geary_ascii_strup (const gchar* str)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 93 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 94 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	_tmp0_ = g_ascii_strup (str, (gssize) -1);
#line 94 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = _tmp0_;
#line 94 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 439 "util-ascii.c"
}


/**
 * Returns true if the ASCII string contains only whitespace and at least one numeric character.
 */
gboolean
geary_ascii_is_numeric (const gchar* str)
{
	gboolean result = FALSE;
	gboolean numeric_found = FALSE;
	gchar* strptr = NULL;
#line 100 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	g_return_val_if_fail (str != NULL, FALSE);
#line 101 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	numeric_found = FALSE;
#line 102 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	strptr = str;
#line 458 "util-ascii.c"
	{
		gboolean _tmp0_ = FALSE;
#line 103 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		_tmp0_ = TRUE;
#line 103 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		while (TRUE) {
#line 465 "util-ascii.c"
			gchar ch = '\0';
			gchar* _tmp1_;
			gchar _tmp2_;
			gchar _tmp3_;
#line 103 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			if (!_tmp0_) {
#line 472 "util-ascii.c"
			}
#line 103 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp0_ = FALSE;
#line 104 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp1_ = strptr;
#line 104 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			strptr = _tmp1_ + 1;
#line 104 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			ch = *_tmp1_;
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp2_ = ch;
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			if (_tmp2_ == GEARY_STRING_EOS) {
#line 107 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
				break;
#line 488 "util-ascii.c"
			}
#line 109 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			_tmp3_ = ch;
#line 109 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
			if (g_ascii_isdigit (_tmp3_)) {
#line 110 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
				numeric_found = TRUE;
#line 496 "util-ascii.c"
			} else {
				gchar _tmp4_;
#line 111 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
				_tmp4_ = ch;
#line 111 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
				if (!g_ascii_isspace (_tmp4_)) {
#line 112 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
					result = FALSE;
#line 112 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
					return result;
#line 507 "util-ascii.c"
				}
			}
		}
	}
#line 115 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = numeric_found;
#line 115 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 516 "util-ascii.c"
}


/**
 * Returns char from 0 to 9 converted to an int.  If a non-numeric value, -1 is returned.
 */
inline gint
geary_ascii_digit_to_int (gchar ch)
{
	gint result = 0;
	gint _tmp0_ = 0;
#line 122 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	if (g_ascii_isdigit (ch)) {
#line 122 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		_tmp0_ = (gint) (ch - '0');
#line 532 "util-ascii.c"
	} else {
#line 122 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
		_tmp0_ = -1;
#line 536 "util-ascii.c"
	}
#line 122 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	result = _tmp0_;
#line 122 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-ascii.vala"
	return result;
#line 542 "util-ascii.c"
}



