/* util-inet.c generated by valac 0.41.91, the Vala compiler
 * generated from util-inet.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



#define GEARY_INET_HOST_PART_REGEX "^(?!-)[\\p{L}\\p{N}-]{1,63}(?<!-)$"
#define GEARY_INET_IPv6_REGEX "^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][" \
"0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$|^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\\-" \
"]*[a-zA-Z0-9])\\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\\-]*[A-Za-z0-9])$|^\\s" \
"*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}" \
"(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|" \
"2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A" \
"-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]" \
"|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9" \
"A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\\d|1\\d\\d|" \
"[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-" \
"Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:(" \
"(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1" \
"-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|" \
"((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(2" \
"5[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(" \
"((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\\" \
"d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:)" \
")|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[" \
"0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3" \
"}))|:)))(%.+)?\\s*$"
gchar* geary_inet_address_to_string (GInetSocketAddress* addr);
gboolean geary_inet_is_valid_display_host (gchar* name);
gboolean geary_string_is_empty (const gchar* str);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Formats a socket address as a "name:port" string.
 */
gchar*
geary_inet_address_to_string (GInetSocketAddress* addr)
{
	gchar* result = NULL;
	GInetAddress* _tmp0_;
	GInetAddress* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 15 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	g_return_val_if_fail (G_IS_INET_SOCKET_ADDRESS (addr), NULL);
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	_tmp0_ = g_inet_socket_address_get_address (addr);
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	_tmp1_ = _tmp0_;
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	_tmp2_ = g_inet_address_to_string (_tmp1_);
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	_tmp3_ = _tmp2_;
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	_tmp4_ = g_inet_socket_address_get_port (addr);
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	_tmp5_ = _tmp4_;
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	_tmp6_ = g_strdup_printf ("%s:%u", _tmp3_, _tmp5_);
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	_tmp7_ = _tmp6_;
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	_g_free0 (_tmp3_);
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	result = _tmp7_;
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	return result;
#line 77 "util-inet.c"
}


/**
 * Determines if a string represents a valid host name or IP address.
 *
 * This function validates a host name or IP address for display,
 * i.e. without IDN or URI encoding. It simply performs a syntactic
 * check, it does not attempt to resolve the host name. Note that both
 * valid IPv4 addresses (such as "123.0.10.100") and invalid IPv4
 * addresses (such as "123" or "555.123.456.789") are valid host
 * names, so it is not possible to determine if an IPv4 address is
 * invalid.
 */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1162 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1162 "glib-2.0.vapi"
	result = _tmp0_;
#line 1162 "glib-2.0.vapi"
	return result;
#line 106 "util-inet.c"
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1407 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1407 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1407 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1408 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 132 "util-inet.c"
		glong _tmp2_;
#line 1409 "glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1409 "glib-2.0.vapi"
		start = _tmp2_ + start;
#line 138 "util-inet.c"
	}
#line 1411 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 142 "util-inet.c"
		glong _tmp3_;
#line 1412 "glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1412 "glib-2.0.vapi"
		end = _tmp3_ + end;
#line 148 "util-inet.c"
	}
#line 1414 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 152 "util-inet.c"
		glong _tmp5_;
#line 1414 "glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1414 "glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 158 "util-inet.c"
	} else {
#line 1414 "glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 162 "util-inet.c"
	}
#line 1414 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1415 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 168 "util-inet.c"
		glong _tmp7_;
#line 1415 "glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1415 "glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 174 "util-inet.c"
	} else {
#line 1415 "glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 178 "util-inet.c"
	}
#line 1415 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1416 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1417 "glib-2.0.vapi"
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1417 "glib-2.0.vapi"
	result = _tmp8_;
#line 1417 "glib-2.0.vapi"
	return result;
#line 190 "util-inet.c"
}


gboolean
geary_inet_is_valid_display_host (gchar* name)
{
	gboolean result = FALSE;
	gboolean is_valid = FALSE;
	GError * _inner_error_ = NULL;
#line 31 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	is_valid = FALSE;
#line 32 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	if (!geary_string_is_empty (name)) {
#line 204 "util-inet.c"
		gint _tmp0_;
		gint _tmp1_;
		gboolean _tmp15_;
#line 35 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
		_tmp0_ = strlen (name);
#line 35 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
		_tmp1_ = _tmp0_;
#line 35 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
		if (_tmp1_ <= 253) {
#line 214 "util-inet.c"
			gint _tmp2_;
			gint _tmp3_;
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
			_tmp2_ = strlen (name);
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
			_tmp3_ = _tmp2_;
#line 36 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
			if (string_get (name, (glong) (_tmp3_ - 1)) == '.') {
#line 223 "util-inet.c"
				gchar* _tmp4_;
#line 37 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_tmp4_ = string_slice (name, (glong) 0, (glong) -1);
#line 37 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_g_free0 (name);
#line 37 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				name = _tmp4_;
#line 231 "util-inet.c"
			}
			{
				GRegex* part_regex = NULL;
				GRegex* _tmp5_;
				gchar** _tmp6_;
				gchar** _tmp7_;
#line 39 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_tmp5_ = g_regex_new (GEARY_INET_HOST_PART_REGEX, 0, 0, &_inner_error_);
#line 39 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				part_regex = _tmp5_;
#line 39 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 244 "util-inet.c"
					goto __catch317_g_error;
				}
#line 40 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				is_valid = TRUE;
#line 41 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_tmp7_ = _tmp6_ = g_strsplit (name, ".", 0);
#line 251 "util-inet.c"
				{
					gchar** part_collection = NULL;
					gint part_collection_length1 = 0;
					gint _part_collection_size_ = 0;
					gint part_it = 0;
#line 41 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
					part_collection = _tmp7_;
#line 41 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
					part_collection_length1 = _vala_array_length (_tmp6_);
#line 41 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
					for (part_it = 0; part_it < _vala_array_length (_tmp6_); part_it = part_it + 1) {
#line 263 "util-inet.c"
						gchar* _tmp8_;
						gchar* part = NULL;
#line 41 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
						_tmp8_ = g_strdup (part_collection[part_it]);
#line 41 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
						part = _tmp8_;
#line 270 "util-inet.c"
						{
							GRegex* _tmp9_;
							const gchar* _tmp10_;
							gboolean _tmp11_;
#line 42 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
							_tmp9_ = part_regex;
#line 42 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
							_tmp10_ = part;
#line 42 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
							_tmp11_ = g_regex_match (_tmp9_, _tmp10_, 0, NULL);
#line 42 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
							if (!_tmp11_) {
#line 43 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
								is_valid = FALSE;
#line 44 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
								_g_free0 (part);
#line 44 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
								break;
#line 289 "util-inet.c"
							}
#line 41 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
							_g_free0 (part);
#line 293 "util-inet.c"
						}
					}
#line 41 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
					part_collection = (_vala_array_free (part_collection, part_collection_length1, (GDestroyNotify) g_free), NULL);
#line 298 "util-inet.c"
				}
#line 38 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_g_regex_unref0 (part_regex);
#line 302 "util-inet.c"
			}
			goto __finally317;
			__catch317_g_error:
			{
				GError* err = NULL;
				GError* _tmp12_;
				const gchar* _tmp13_;
#line 38 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				err = _inner_error_;
#line 38 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_inner_error_ = NULL;
#line 48 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_tmp12_ = err;
#line 48 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_tmp13_ = _tmp12_->message;
#line 48 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				g_debug ("util-inet.vala:48: Error validating as host name: %s", _tmp13_);
#line 38 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_g_error_free0 (err);
#line 322 "util-inet.c"
			}
			__finally317:
#line 38 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 327 "util-inet.c"
				gboolean _tmp14_ = FALSE;
#line 38 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_g_free0 (name);
#line 38 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 38 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				g_clear_error (&_inner_error_);
#line 38 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				return _tmp14_;
#line 337 "util-inet.c"
			}
		}
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
		_tmp15_ = is_valid;
#line 53 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
		if (!_tmp15_) {
#line 344 "util-inet.c"
			{
				GRegex* address_regex = NULL;
				GRegex* _tmp16_;
				GRegex* _tmp17_;
				gboolean _tmp18_;
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_tmp16_ = g_regex_new (GEARY_INET_IPv6_REGEX, G_REGEX_CASELESS, 0, &_inner_error_);
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				address_regex = _tmp16_;
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 356 "util-inet.c"
					goto __catch318_g_error;
				}
#line 58 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_tmp17_ = address_regex;
#line 58 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_tmp18_ = g_regex_match (_tmp17_, name, 0, NULL);
#line 58 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				is_valid = _tmp18_;
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_g_regex_unref0 (address_regex);
#line 367 "util-inet.c"
			}
			goto __finally318;
			__catch318_g_error:
			{
				GError* err = NULL;
				GError* _tmp19_;
				const gchar* _tmp20_;
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				err = _inner_error_;
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_inner_error_ = NULL;
#line 60 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_tmp19_ = err;
#line 60 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_tmp20_ = _tmp19_->message;
#line 60 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				g_debug ("util-inet.vala:60: Error validating as IPv6 address: %s", _tmp20_);
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_g_error_free0 (err);
#line 387 "util-inet.c"
			}
			__finally318:
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 392 "util-inet.c"
				gboolean _tmp21_ = FALSE;
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				_g_free0 (name);
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				g_clear_error (&_inner_error_);
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
				return _tmp21_;
#line 402 "util-inet.c"
			}
		}
	}
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	result = is_valid;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	_g_free0 (name);
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-inet.vala"
	return result;
#line 412 "util-inet.c"
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



