/* util-js.c generated by valac 0.41.91, the Vala compiler
 * generated from util-js.vala, do not modify */

/*
 * Copyright 2017 Michael James Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <JavaScriptCore/JavaScript.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#define _0(var) ((var == NULL) ? NULL : (var = ( (var), NULL)))
#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define GEARY_JS_TYPE_CALLABLE (geary_js_callable_get_type ())
#define GEARY_JS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_JS_TYPE_CALLABLE, GearyJSCallable))
#define GEARY_JS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_JS_TYPE_CALLABLE, GearyJSCallableClass))
#define GEARY_JS_IS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_JS_TYPE_CALLABLE))
#define GEARY_JS_IS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_JS_TYPE_CALLABLE))
#define GEARY_JS_CALLABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_JS_TYPE_CALLABLE, GearyJSCallableClass))

typedef struct _GearyJSCallable GearyJSCallable;
typedef struct _GearyJSCallableClass GearyJSCallableClass;
typedef struct _GearyJSCallablePrivate GearyJSCallablePrivate;
typedef struct _GearyJSParamSpecCallable GearyJSParamSpecCallable;

/**
     * Errors produced by functions in {@link Geary.JS}.
     */
typedef enum  {
	GEARY_JS_ERROR_EXCEPTION,
	GEARY_JS_ERROR_TYPE
} GearyJSError;
#define GEARY_JS_ERROR geary_js_error_quark ()
struct _GearyJSCallable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GearyJSCallablePrivate * priv;
};

struct _GearyJSCallableClass {
	GTypeClass parent_class;
	void (*finalize) (GearyJSCallable *self);
};

struct _GearyJSCallablePrivate {
	gchar* base_name;
	gchar** safe_args;
	gint safe_args_length1;
	gint _safe_args_size_;
};

struct _GearyJSParamSpecCallable {
	GParamSpec parent_instance;
};


static gint GearyJSCallable_private_offset;
static gpointer geary_js_callable_parent_class = NULL;

GQuark geary_js_error_quark (void);
gboolean geary_js_is_null (const struct OpaqueJSContext* context,
                           const struct OpaqueJSValue* js);
gdouble geary_js_to_number (const struct OpaqueJSContext* context,
                            const struct OpaqueJSValue* value,
                            GError** error);
void geary_js_check_exception (const struct OpaqueJSContext* context,
                               const struct OpaqueJSValue* err_value,
                               GError** error);
gchar* geary_js_to_string (const struct OpaqueJSContext* context,
                           const struct OpaqueJSValue* value,
                           GError** error);
gchar* geary_js_to_native_string (struct OpaqueJSString* js);
struct OpaqueJSValue* geary_js_to_object (const struct OpaqueJSContext* context,
                                          const struct OpaqueJSValue* value,
                                          GError** error);
const struct OpaqueJSValue* geary_js_get_property (const struct OpaqueJSContext* context,
                                                   struct OpaqueJSValue* object,
                                                   const gchar* name,
                                                   GError** error);
const gchar* JS_type_to_string (JSType self);
static const char* _JS_type_to_string (JSType value);
gchar* geary_js_escape_string (const gchar* value);
gpointer geary_js_callable_ref (gpointer instance);
void geary_js_callable_unref (gpointer instance);
GParamSpec* geary_js_param_spec_callable (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void geary_js_value_set_callable (GValue* value,
                                  gpointer v_object);
void geary_js_value_take_callable (GValue* value,
                                   gpointer v_object);
gpointer geary_js_value_get_callable (const GValue* value);
GType geary_js_callable_get_type (void) G_GNUC_CONST;
GearyJSCallable* geary_js_callable (const gchar* base_name);
GearyJSCallable* geary_js_callable_new (const gchar* base_name);
GearyJSCallable* geary_js_callable_construct (GType object_type,
                                              const gchar* base_name);
gchar* geary_js_callable_to_string (GearyJSCallable* self);
GearyJSCallable* geary_js_callable_string (GearyJSCallable* self,
                                           const gchar* value);
static inline void geary_js_callable_add_param (GearyJSCallable* self,
                                  const gchar* value);
GearyJSCallable* geary_js_callable_double (GearyJSCallable* self,
                                           gdouble value);
GearyJSCallable* geary_js_callable_int (GearyJSCallable* self,
                                        gint value);
GearyJSCallable* geary_js_callable_bool (GearyJSCallable* self,
                                         gboolean value);
static void _vala_array_add23 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void geary_js_callable_finalize (GearyJSCallable * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


GQuark
geary_js_error_quark (void)
{
	return g_quark_from_static_string ("geary_js_error-quark");
}


/**
     * Determines if a {@link JS.Value} object is {{{null}}}.
     *
     * @return `true` if `js` is `null` or has a {@link JS.Type} of
     * `NULL` according to `context`.
     */
inline gboolean
geary_js_is_null (const struct OpaqueJSContext* context,
                  const struct OpaqueJSValue* js)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 44 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (js == NULL) {
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp0_ = TRUE;
#line 162 "util-js.c"
	} else {
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp0_ = JSValueGetType (context, js) == kJSTypeNull;
#line 166 "util-js.c"
	}
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp0_;
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 172 "util-js.c"
}


/**
     * Returns a JSC Value as a number.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `Number`.
     */
gdouble
geary_js_to_number (const struct OpaqueJSContext* context,
                    const struct OpaqueJSValue* value,
                    GError** error)
{
	gdouble result = 0.0;
	const struct OpaqueJSValue* err = NULL;
	gdouble number = 0.0;
	const struct OpaqueJSValue* _tmp3_ = NULL;
	gdouble _tmp4_;
	const struct OpaqueJSValue* _tmp5_;
	GError * _inner_error_ = NULL;
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (context != NULL, 0.0);
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, 0.0);
#line 58 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (!JSValueIsNumber (context, value)) {
#line 200 "util-js.c"
		GError* _tmp0_;
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp0_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS Number object");
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_inner_error_ = _tmp0_;
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 208 "util-js.c"
			gdouble _tmp1_ = -1.0;
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return _tmp1_;
#line 214 "util-js.c"
		} else {
			gdouble _tmp2_ = -1.0;
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return _tmp2_;
#line 223 "util-js.c"
		}
	}
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = NULL;
#line 63 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp4_ = JSValueToNumber (context, value, &_tmp3_);
#line 63 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_0 (err);
#line 63 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = _tmp3_;
#line 63 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	number = _tmp4_;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp5_ = err;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_check_exception (context, _tmp5_, &_inner_error_);
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 244 "util-js.c"
			gdouble _tmp6_ = -1.0;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (err);
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return _tmp6_;
#line 252 "util-js.c"
		} else {
			gdouble _tmp7_ = -1.0;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (err);
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return _tmp7_;
#line 263 "util-js.c"
		}
	}
#line 65 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = number;
#line 65 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_0 (err);
#line 65 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 272 "util-js.c"
}


/**
     * Returns a JSC Value as a string.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `String`.
     */
gchar*
geary_js_to_string (const struct OpaqueJSContext* context,
                    const struct OpaqueJSValue* value,
                    GError** error)
{
	gchar* result = NULL;
	const struct OpaqueJSValue* err = NULL;
	struct OpaqueJSString* js_str = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	struct OpaqueJSString* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	gchar* _tmp4_;
	GError * _inner_error_ = NULL;
#line 74 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 74 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 77 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (!JSValueIsString (context, value)) {
#line 301 "util-js.c"
		GError* _tmp0_;
#line 78 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp0_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS String object");
#line 78 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_inner_error_ = _tmp0_;
#line 78 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 78 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 78 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 313 "util-js.c"
		} else {
#line 78 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 78 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 78 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 321 "util-js.c"
		}
	}
#line 81 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = NULL;
#line 82 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = JSValueToStringCopy (context, value, &_tmp1_);
#line 82 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_0 (err);
#line 82 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = _tmp1_;
#line 82 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	js_str = _tmp2_;
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = err;
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_check_exception (context, _tmp3_, &_inner_error_);
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_JSStringRelease0 (js_str);
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (err);
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 350 "util-js.c"
		} else {
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_JSStringRelease0 (js_str);
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (err);
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 83 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 362 "util-js.c"
		}
	}
#line 85 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp4_ = geary_js_to_native_string (js_str);
#line 85 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp4_;
#line 85 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_JSStringRelease0 (js_str);
#line 85 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_0 (err);
#line 85 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 375 "util-js.c"
}


/**
     * Returns a JSC Value as an object.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `Object`.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
struct OpaqueJSValue*
geary_js_to_object (const struct OpaqueJSContext* context,
                    const struct OpaqueJSValue* value,
                    GError** error)
{
	struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSValue* err = NULL;
	struct OpaqueJSValue* js_obj = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	struct OpaqueJSValue* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	GError * _inner_error_ = NULL;
#line 97 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 97 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 100 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (!JSValueIsObject (context, value)) {
#line 406 "util-js.c"
		GError* _tmp0_;
#line 101 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp0_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS Object");
#line 101 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_inner_error_ = _tmp0_;
#line 101 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 101 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 101 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 418 "util-js.c"
		} else {
#line 101 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 101 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 101 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 426 "util-js.c"
		}
	}
#line 104 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = NULL;
#line 105 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = JSValueToObject (context, value, &_tmp1_);
#line 105 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_0 (err);
#line 105 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = _tmp1_;
#line 105 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	js_obj = _tmp2_;
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = err;
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_check_exception (context, _tmp3_, &_inner_error_);
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (js_obj);
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (err);
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 455 "util-js.c"
		} else {
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (js_obj);
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (err);
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 106 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 467 "util-js.c"
		}
	}
#line 108 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = js_obj;
#line 108 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_0 (err);
#line 108 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 476 "util-js.c"
}


/**
     * Returns a JSC {@link JS.String} as a Vala {@link string}.
     */
inline gchar*
geary_js_to_native_string (struct OpaqueJSString* js)
{
	gchar* result = NULL;
	gsize len = 0UL;
	guint8* str = NULL;
	guint8* _tmp0_;
	gint str_length1;
	gint _str_size_;
	gchar* _tmp1_;
#line 114 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (js != NULL, NULL);
#line 115 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	len = JSStringGetMaximumUTF8CStringSize (js);
#line 116 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = g_new0 (guint8, len);
#line 116 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	str = _tmp0_;
#line 116 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	str_length1 = len;
#line 116 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_str_size_ = str_length1;
#line 118 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	JSStringGetUTF8CString (js, str, (gsize) str_length1);
#line 122 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = g_strdup ((const gchar*) str);
#line 122 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp1_;
#line 122 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	str = (g_free (str), NULL);
#line 122 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 515 "util-js.c"
}


/**
     * Returns the value of an object's property.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * object does not contain the named property.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
inline const struct OpaqueJSValue*
geary_js_get_property (const struct OpaqueJSContext* context,
                       struct OpaqueJSValue* object,
                       const gchar* name,
                       GError** error)
{
	const struct OpaqueJSValue* result = NULL;
	struct OpaqueJSString* js_name = NULL;
	struct OpaqueJSString* _tmp0_;
	const struct OpaqueJSValue* err = NULL;
	const struct OpaqueJSValue* prop = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	const struct OpaqueJSValue* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	GError * _inner_error_ = NULL;
#line 134 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 134 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (object != NULL, NULL);
#line 134 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 138 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = JSStringCreateWithUTF8CString (name);
#line 138 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	js_name = _tmp0_;
#line 139 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = NULL;
#line 140 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = JSObjectGetProperty (context, object, js_name, &_tmp1_);
#line 140 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_0 (err);
#line 140 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	err = _tmp1_;
#line 140 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	prop = _tmp2_;
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = err;
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_check_exception (context, _tmp3_, &_inner_error_);
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (prop);
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (err);
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_JSStringRelease0 (js_name);
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 581 "util-js.c"
		} else {
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (prop);
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (err);
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_JSStringRelease0 (js_name);
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 141 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return NULL;
#line 595 "util-js.c"
		}
	}
#line 143 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = prop;
#line 143 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_0 (err);
#line 143 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_JSStringRelease0 (js_name);
#line 143 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 606 "util-js.c"
}


/**
     * Checks an JS exception returned from a JSC call.
     *
     * This method will raise a {@link Geary.JS.Error} if the given
     * `err_value` is not null (in a Vala or JS sense).
     */
static const char*
_JS_type_to_string (JSType value)
{
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	switch (value) {
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		case kJSTypeUndefined:
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return "kJSTypeUndefined";
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		case kJSTypeNull:
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return "kJSTypeNull";
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		case kJSTypeBoolean:
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return "kJSTypeBoolean";
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		case kJSTypeNumber:
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return "kJSTypeNumber";
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		case kJSTypeString:
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return "kJSTypeString";
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		case kJSTypeObject:
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return "kJSTypeObject";
#line 645 "util-js.c"
	}
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return NULL;
#line 649 "util-js.c"
}


inline void
geary_js_check_exception (const struct OpaqueJSContext* context,
                          const struct OpaqueJSValue* err_value,
                          GError** error)
{
	GError * _inner_error_ = NULL;
#line 152 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_if_fail (context != NULL);
#line 155 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (!geary_js_is_null (context, err_value)) {
#line 663 "util-js.c"
		const struct OpaqueJSValue* nested_err = NULL;
		JSType err_type = 0;
		struct OpaqueJSString* err_str = NULL;
		const struct OpaqueJSValue* _tmp0_ = NULL;
		struct OpaqueJSString* _tmp1_;
		const struct OpaqueJSValue* _tmp2_;
		JSType _tmp6_;
		const gchar* _tmp7_;
		struct OpaqueJSString* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GError* _tmp13_;
		GError* _tmp14_;
#line 156 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		nested_err = NULL;
#line 157 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		err_type = JSValueGetType (context, err_value);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp1_ = JSValueToStringCopy (context, err_value, &_tmp0_);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_0 (nested_err);
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		nested_err = _tmp0_;
#line 158 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		err_str = _tmp1_;
#line 161 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp2_ = nested_err;
#line 161 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (!geary_js_is_null (context, _tmp2_)) {
#line 695 "util-js.c"
			JSType _tmp3_;
			const gchar* _tmp4_;
			GError* _tmp5_;
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_tmp3_ = err_type;
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_tmp4_ = _JS_type_to_string (_tmp3_);
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_tmp5_ = g_error_new (GEARY_JS_ERROR, GEARY_JS_ERROR_EXCEPTION, "Nested exception getting exception %s as a string", _tmp4_);
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_inner_error_ = _tmp5_;
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				g_propagate_error (error, _inner_error_);
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_JSStringRelease0 (err_str);
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_0 (nested_err);
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				return;
#line 717 "util-js.c"
			} else {
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_JSStringRelease0 (err_str);
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_0 (nested_err);
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				g_clear_error (&_inner_error_);
#line 162 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				return;
#line 729 "util-js.c"
			}
		}
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp6_ = err_type;
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp7_ = _JS_type_to_string (_tmp6_);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp8_ = err_str;
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp9_ = geary_js_to_native_string (_tmp8_);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp10_ = _tmp9_;
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp11_ = g_strdup_printf ("JS exception thrown [%s]: %s", _tmp7_, _tmp10_);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp12_ = _tmp11_;
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp13_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_EXCEPTION, _tmp12_);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp14_ = _tmp13_;
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_g_free0 (_tmp12_);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_g_free0 (_tmp10_);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_inner_error_ = _tmp14_;
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error_);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_JSStringRelease0 (err_str);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (nested_err);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return;
#line 766 "util-js.c"
		} else {
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_JSStringRelease0 (err_str);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_0 (nested_err);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			g_clear_error (&_inner_error_);
#line 168 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return;
#line 778 "util-js.c"
		}
#line 155 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_JSStringRelease0 (err_str);
#line 155 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_0 (nested_err);
#line 784 "util-js.c"
	}
}


/**
     * Escapes a string so as to be safe to use as a JS string literal.
     *
     * This does not append opening or closing quotes.
     */
static gboolean
string_valid_char (const gchar* self,
                   gint index)
{
	gboolean result = FALSE;
	guint8 c = 0U;
	guint8 _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	guint8 _tmp3_;
#line 1167 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1168 "glib-2.0.vapi"
	_tmp0_ = ((guint8*) self)[index];
#line 1168 "glib-2.0.vapi"
	c = _tmp0_;
#line 1169 "glib-2.0.vapi"
	_tmp3_ = c;
#line 1169 "glib-2.0.vapi"
	if (((gint) _tmp3_) == 0x00) {
#line 1169 "glib-2.0.vapi"
		_tmp2_ = TRUE;
#line 816 "util-js.c"
	} else {
		gboolean _tmp4_ = FALSE;
		guint8 _tmp5_;
#line 1169 "glib-2.0.vapi"
		_tmp5_ = c;
#line 1169 "glib-2.0.vapi"
		if (((gint) _tmp5_) >= 0x80) {
#line 824 "util-js.c"
			guint8 _tmp6_;
#line 1169 "glib-2.0.vapi"
			_tmp6_ = c;
#line 1169 "glib-2.0.vapi"
			_tmp4_ = ((gint) _tmp6_) < 0xc2;
#line 830 "util-js.c"
		} else {
#line 1169 "glib-2.0.vapi"
			_tmp4_ = FALSE;
#line 834 "util-js.c"
		}
#line 1169 "glib-2.0.vapi"
		_tmp2_ = _tmp4_;
#line 838 "util-js.c"
	}
#line 1169 "glib-2.0.vapi"
	if (_tmp2_) {
#line 1169 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 844 "util-js.c"
	} else {
		guint8 _tmp7_;
#line 1169 "glib-2.0.vapi"
		_tmp7_ = c;
#line 1169 "glib-2.0.vapi"
		_tmp1_ = ((gint) _tmp7_) >= 0xf5;
#line 851 "util-js.c"
	}
#line 1169 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1170 "glib-2.0.vapi"
		result = FALSE;
#line 1170 "glib-2.0.vapi"
		return result;
#line 859 "util-js.c"
	} else {
#line 1172 "glib-2.0.vapi"
		result = TRUE;
#line 1172 "glib-2.0.vapi"
		return result;
#line 865 "util-js.c"
	}
}


static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1191 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1192 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1192 "glib-2.0.vapi"
	return result;
#line 881 "util-js.c"
}


static guint8*
g_string_get_data (GString* self,
                   int* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	gssize _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
#line 4952 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 4953 "glib-2.0.vapi"
	_tmp0_ = self->str;
#line 4953 "glib-2.0.vapi"
	res = (guint8*) _tmp0_;
#line 4953 "glib-2.0.vapi"
	res_length1 = -1;
#line 4953 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 4954 "glib-2.0.vapi"
	_tmp1_ = self->len;
#line 4954 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 4954 "glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 4955 "glib-2.0.vapi"
	_tmp3_ = res;
#line 4955 "glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 4955 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 4955 "glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 4955 "glib-2.0.vapi"
	if (result_length1) {
#line 4955 "glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 928 "util-js.c"
	}
#line 4955 "glib-2.0.vapi"
	result = _tmp4_;
#line 4955 "glib-2.0.vapi"
	return result;
#line 934 "util-js.c"
}


gchar*
geary_js_escape_string (const gchar* value)
{
	gchar* result = NULL;
	GString* builder = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GString* _tmp2_;
	GString* _tmp23_;
	guint8* _tmp24_;
	gint _tmp24__length1;
	guint8* _tmp25_;
	gint _tmp25__length1;
	gchar* _tmp26_;
#line 180 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 181 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = strlen (value);
#line 181 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 181 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = g_string_sized_new ((gsize) _tmp1_);
#line 181 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	builder = _tmp2_;
#line 962 "util-js.c"
	{
		gint i = 0;
#line 182 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		i = 0;
#line 967 "util-js.c"
		{
			gboolean _tmp3_ = FALSE;
#line 182 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			_tmp3_ = TRUE;
#line 182 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			while (TRUE) {
#line 974 "util-js.c"
				gint _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 182 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				if (!_tmp3_) {
#line 981 "util-js.c"
					gint _tmp4_;
#line 182 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					_tmp4_ = i;
#line 182 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					i = _tmp4_ + 1;
#line 987 "util-js.c"
				}
#line 182 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp3_ = FALSE;
#line 182 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp5_ = i;
#line 182 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp6_ = strlen (value);
#line 182 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp7_ = _tmp6_;
#line 182 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				if (!(_tmp5_ < _tmp7_)) {
#line 182 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					break;
#line 1001 "util-js.c"
				}
#line 183 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				_tmp8_ = i;
#line 183 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
				if (string_valid_char (value, _tmp8_)) {
#line 1007 "util-js.c"
					gunichar c = 0U;
					gint _tmp9_;
					gunichar _tmp10_;
#line 184 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					_tmp9_ = i;
#line 184 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					c = string_get_char (value, (glong) _tmp9_);
#line 185 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					_tmp10_ = c;
#line 185 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
					switch (_tmp10_) {
#line 185 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\x00':
#line 1021 "util-js.c"
						{
							GString* _tmp11_;
#line 187 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp11_ = builder;
#line 187 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp11_, "\x00");
#line 188 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1030 "util-js.c"
						}
#line 185 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\'':
#line 1034 "util-js.c"
						{
							GString* _tmp12_;
#line 190 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp12_ = builder;
#line 190 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp12_, "\\'");
#line 191 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1043 "util-js.c"
						}
#line 185 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '"':
#line 1047 "util-js.c"
						{
							GString* _tmp13_;
#line 193 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp13_ = builder;
#line 193 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp13_, "\\\"");
#line 194 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1056 "util-js.c"
						}
#line 185 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\\':
#line 1060 "util-js.c"
						{
							GString* _tmp14_;
#line 196 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp14_ = builder;
#line 196 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp14_, "\\\\");
#line 197 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1069 "util-js.c"
						}
#line 185 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\n':
#line 1073 "util-js.c"
						{
							GString* _tmp15_;
#line 199 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp15_ = builder;
#line 199 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp15_, "\\n");
#line 200 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1082 "util-js.c"
						}
#line 185 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\r':
#line 1086 "util-js.c"
						{
							GString* _tmp16_;
#line 202 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp16_ = builder;
#line 202 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp16_, "\\r");
#line 203 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1095 "util-js.c"
						}
#line 185 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\x0b':
#line 1099 "util-js.c"
						{
							GString* _tmp17_;
#line 205 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp17_ = builder;
#line 205 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp17_, "\x0b");
#line 206 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1108 "util-js.c"
						}
#line 185 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\t':
#line 1112 "util-js.c"
						{
							GString* _tmp18_;
#line 208 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp18_ = builder;
#line 208 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp18_, "\\t");
#line 209 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1121 "util-js.c"
						}
#line 185 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\b':
#line 1125 "util-js.c"
						{
							GString* _tmp19_;
#line 211 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp19_ = builder;
#line 211 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp19_, "\\b");
#line 212 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1134 "util-js.c"
						}
#line 185 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
						case '\f':
#line 1138 "util-js.c"
						{
							GString* _tmp20_;
#line 214 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp20_ = builder;
#line 214 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append (_tmp20_, "\\f");
#line 215 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1147 "util-js.c"
						}
						default:
						{
							GString* _tmp21_;
							gunichar _tmp22_;
#line 217 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp21_ = builder;
#line 217 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							_tmp22_ = c;
#line 217 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							g_string_append_unichar (_tmp21_, _tmp22_);
#line 218 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
							break;
#line 1161 "util-js.c"
						}
					}
				}
			}
		}
	}
#line 222 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp23_ = builder;
#line 222 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp24_ = g_string_get_data (_tmp23_, &_tmp24__length1);
#line 222 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp25_ = _tmp24_;
#line 222 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp25__length1 = _tmp24__length1;
#line 222 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp26_ = g_strdup ((const gchar*) _tmp25_);
#line 222 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp26_;
#line 222 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_string_free0 (builder);
#line 222 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1184 "util-js.c"
}


/**
     * Convenience method for returning a new Callable instance.
     */
GearyJSCallable*
geary_js_callable (const gchar* base_name)
{
	GearyJSCallable* result = NULL;
	GearyJSCallable* _tmp0_;
#line 228 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (base_name != NULL, NULL);
#line 229 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = geary_js_callable_new (base_name);
#line 229 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp0_;
#line 229 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1204 "util-js.c"
}


static inline gpointer
geary_js_callable_get_instance_private (GearyJSCallable* self)
{
	return G_STRUCT_MEMBER_P (self, GearyJSCallable_private_offset);
}


GearyJSCallable*
geary_js_callable_construct (GType object_type,
                             const gchar* base_name)
{
	GearyJSCallable* self = NULL;
	gchar* _tmp0_;
#line 241 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (base_name != NULL, NULL);
#line 241 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self = (GearyJSCallable*) g_type_create_instance (object_type);
#line 242 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = g_strdup (base_name);
#line 242 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (self->priv->base_name);
#line 242 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->priv->base_name = _tmp0_;
#line 241 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return self;
#line 1233 "util-js.c"
}


GearyJSCallable*
geary_js_callable_new (const gchar* base_name)
{
#line 241 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return geary_js_callable_construct (GEARY_JS_TYPE_CALLABLE, base_name);
#line 1242 "util-js.c"
}


static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  int str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 1129 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1130 "glib-2.0.vapi"
		separator = "";
#line 1257 "util-js.c"
	}
#line 1132 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 1261 "util-js.c"
		gboolean _tmp1_ = FALSE;
#line 1132 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1132 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1267 "util-js.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1132 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1272 "util-js.c"
				const gchar* _tmp3_;
#line 1132 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1132 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1278 "util-js.c"
			} else {
#line 1132 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1282 "util-js.c"
			}
#line 1132 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1286 "util-js.c"
		}
#line 1132 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1290 "util-js.c"
	} else {
#line 1132 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1294 "util-js.c"
	}
#line 1132 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1298 "util-js.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp20_;
		gint _tmp22_;
		gint _tmp23_;
		gsize _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		const gchar* res = NULL;
		gsize _tmp28_;
		void* _tmp29_;
		void* ptr = NULL;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		void* _tmp32_;
		const gchar* _tmp45_;
#line 1134 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1318 "util-js.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1135 "glib-2.0.vapi"
			i = 0;
#line 1135 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1135 "glib-2.0.vapi"
			while (TRUE) {
#line 1327 "util-js.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp12_ = 0;
				gint _tmp13_;
				const gchar* _tmp14_;
				gsize _tmp19_;
#line 1135 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1336 "util-js.c"
					gint _tmp5_;
#line 1135 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1135 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1342 "util-js.c"
				}
#line 1135 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1135 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1348 "util-js.c"
					gint _tmp8_;
#line 1135 "glib-2.0.vapi"
					_tmp8_ = i;
#line 1135 "glib-2.0.vapi"
					_tmp7_ = _tmp8_ < str_array_length1;
#line 1354 "util-js.c"
				} else {
#line 1135 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1358 "util-js.c"
				}
#line 1135 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1135 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1364 "util-js.c"
				} else {
					gboolean _tmp9_ = FALSE;
#line 1135 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1369 "util-js.c"
						gint _tmp10_;
						const gchar* _tmp11_;
#line 1135 "glib-2.0.vapi"
						_tmp10_ = i;
#line 1135 "glib-2.0.vapi"
						_tmp11_ = str_array[_tmp10_];
#line 1135 "glib-2.0.vapi"
						_tmp9_ = _tmp11_ != NULL;
#line 1378 "util-js.c"
					} else {
#line 1135 "glib-2.0.vapi"
						_tmp9_ = FALSE;
#line 1382 "util-js.c"
					}
#line 1135 "glib-2.0.vapi"
					_tmp6_ = _tmp9_;
#line 1386 "util-js.c"
				}
#line 1135 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1135 "glib-2.0.vapi"
					break;
#line 1392 "util-js.c"
				}
#line 1136 "glib-2.0.vapi"
				_tmp13_ = i;
#line 1136 "glib-2.0.vapi"
				_tmp14_ = str_array[_tmp13_];
#line 1136 "glib-2.0.vapi"
				if (_tmp14_ != NULL) {
#line 1400 "util-js.c"
					gint _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
#line 1136 "glib-2.0.vapi"
					_tmp15_ = i;
#line 1136 "glib-2.0.vapi"
					_tmp16_ = str_array[_tmp15_];
#line 1136 "glib-2.0.vapi"
					_tmp17_ = strlen ((const gchar*) _tmp16_);
#line 1136 "glib-2.0.vapi"
					_tmp18_ = _tmp17_;
#line 1136 "glib-2.0.vapi"
					_tmp12_ = _tmp18_;
#line 1415 "util-js.c"
				} else {
#line 1136 "glib-2.0.vapi"
					_tmp12_ = 0;
#line 1419 "util-js.c"
				}
#line 1136 "glib-2.0.vapi"
				_tmp19_ = len;
#line 1136 "glib-2.0.vapi"
				len = _tmp19_ + _tmp12_;
#line 1425 "util-js.c"
			}
		}
#line 1138 "glib-2.0.vapi"
		_tmp20_ = i;
#line 1138 "glib-2.0.vapi"
		if (_tmp20_ == 0) {
#line 1432 "util-js.c"
			gchar* _tmp21_;
#line 1139 "glib-2.0.vapi"
			_tmp21_ = g_strdup ("");
#line 1139 "glib-2.0.vapi"
			result = _tmp21_;
#line 1139 "glib-2.0.vapi"
			return result;
#line 1440 "util-js.c"
		}
#line 1141 "glib-2.0.vapi"
		_tmp22_ = i;
#line 1141 "glib-2.0.vapi"
		str_array_length1 = _tmp22_;
#line 1141 "glib-2.0.vapi"
		_tmp23_ = str_array_length1;
#line 1142 "glib-2.0.vapi"
		_tmp24_ = len;
#line 1142 "glib-2.0.vapi"
		_tmp25_ = strlen ((const gchar*) separator);
#line 1142 "glib-2.0.vapi"
		_tmp26_ = _tmp25_;
#line 1142 "glib-2.0.vapi"
		_tmp27_ = i;
#line 1142 "glib-2.0.vapi"
		len = _tmp24_ + (_tmp26_ * (_tmp27_ - 1));
#line 1144 "glib-2.0.vapi"
		_tmp28_ = len;
#line 1144 "glib-2.0.vapi"
		_tmp29_ = g_malloc (_tmp28_);
#line 1144 "glib-2.0.vapi"
		res = _tmp29_;
#line 1145 "glib-2.0.vapi"
		_tmp30_ = res;
#line 1145 "glib-2.0.vapi"
		_tmp31_ = str_array[0];
#line 1145 "glib-2.0.vapi"
		_tmp32_ = g_stpcpy ((void*) _tmp30_, (const gchar*) _tmp31_);
#line 1145 "glib-2.0.vapi"
		ptr = _tmp32_;
#line 1472 "util-js.c"
		{
			gboolean _tmp33_ = FALSE;
#line 1146 "glib-2.0.vapi"
			i = 1;
#line 1146 "glib-2.0.vapi"
			_tmp33_ = TRUE;
#line 1146 "glib-2.0.vapi"
			while (TRUE) {
#line 1481 "util-js.c"
				gint _tmp35_;
				void* _tmp36_;
				void* _tmp37_;
				const gchar* _tmp38_ = NULL;
				gint _tmp39_;
				const gchar* _tmp40_;
				void* _tmp43_;
				void* _tmp44_;
#line 1146 "glib-2.0.vapi"
				if (!_tmp33_) {
#line 1492 "util-js.c"
					gint _tmp34_;
#line 1146 "glib-2.0.vapi"
					_tmp34_ = i;
#line 1146 "glib-2.0.vapi"
					i = _tmp34_ + 1;
#line 1498 "util-js.c"
				}
#line 1146 "glib-2.0.vapi"
				_tmp33_ = FALSE;
#line 1146 "glib-2.0.vapi"
				_tmp35_ = i;
#line 1146 "glib-2.0.vapi"
				if (!(_tmp35_ < str_array_length1)) {
#line 1146 "glib-2.0.vapi"
					break;
#line 1508 "util-js.c"
				}
#line 1147 "glib-2.0.vapi"
				_tmp36_ = ptr;
#line 1147 "glib-2.0.vapi"
				_tmp37_ = g_stpcpy (_tmp36_, (const gchar*) separator);
#line 1147 "glib-2.0.vapi"
				ptr = _tmp37_;
#line 1148 "glib-2.0.vapi"
				_tmp39_ = i;
#line 1148 "glib-2.0.vapi"
				_tmp40_ = str_array[_tmp39_];
#line 1148 "glib-2.0.vapi"
				if (_tmp40_ != NULL) {
#line 1522 "util-js.c"
					gint _tmp41_;
					const gchar* _tmp42_;
#line 1148 "glib-2.0.vapi"
					_tmp41_ = i;
#line 1148 "glib-2.0.vapi"
					_tmp42_ = str_array[_tmp41_];
#line 1148 "glib-2.0.vapi"
					_tmp38_ = (const gchar*) _tmp42_;
#line 1531 "util-js.c"
				} else {
#line 1148 "glib-2.0.vapi"
					_tmp38_ = "";
#line 1535 "util-js.c"
				}
#line 1148 "glib-2.0.vapi"
				_tmp43_ = ptr;
#line 1148 "glib-2.0.vapi"
				_tmp44_ = g_stpcpy (_tmp43_, _tmp38_);
#line 1148 "glib-2.0.vapi"
				ptr = _tmp44_;
#line 1543 "util-js.c"
			}
		}
#line 1151 "glib-2.0.vapi"
		_tmp45_ = res;
#line 1151 "glib-2.0.vapi"
		res = NULL;
#line 1151 "glib-2.0.vapi"
		result = (gchar*) _tmp45_;
#line 1151 "glib-2.0.vapi"
		return result;
#line 1554 "util-js.c"
	} else {
		gchar* _tmp46_;
#line 1153 "glib-2.0.vapi"
		_tmp46_ = g_strdup ("");
#line 1153 "glib-2.0.vapi"
		result = _tmp46_;
#line 1153 "glib-2.0.vapi"
		return result;
#line 1563 "util-js.c"
	}
}


gchar*
geary_js_callable_to_string (GearyJSCallable* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 245 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = self->priv->base_name;
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = g_strconcat (_tmp0_, "(", NULL);
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = _tmp1_;
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = self->priv->safe_args;
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3__length1 = self->priv->safe_args_length1;
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp4_ = _vala_g_strjoinv (",", _tmp3_, _tmp3__length1);
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp5_ = _tmp4_;
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp7_ = _tmp6_;
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp8_ = g_strconcat (_tmp7_, ");", NULL);
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp9_ = _tmp8_;
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp7_);
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp5_);
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp2_);
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp9_;
#line 246 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1617 "util-js.c"
}


static gpointer
_geary_js_callable_ref0 (gpointer self)
{
#line 251 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return self ? geary_js_callable_ref (self) : NULL;
#line 1626 "util-js.c"
}


GearyJSCallable*
geary_js_callable_string (GearyJSCallable* self,
                          const gchar* value)
{
	GearyJSCallable* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GearyJSCallable* _tmp6_;
#line 249 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 249 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = geary_js_escape_string (value);
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = g_strconcat ("\"", _tmp1_, NULL);
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp3_ = _tmp2_;
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp4_ = g_strconcat (_tmp3_, "\"", NULL);
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp5_ = _tmp4_;
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp5_);
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp5_);
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp3_);
#line 250 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp1_);
#line 251 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp6_ = _geary_js_callable_ref0 (self);
#line 251 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp6_;
#line 251 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1672 "util-js.c"
}


static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 919 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 919 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 919 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 919 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
#line 919 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 919 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 919 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 919 "glib-2.0.vapi"
	result = _tmp4_;
#line 919 "glib-2.0.vapi"
	return result;
#line 1704 "util-js.c"
}


GearyJSCallable*
geary_js_callable_double (GearyJSCallable* self,
                          gdouble value)
{
	GearyJSCallable* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyJSCallable* _tmp2_;
#line 254 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 255 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = double_to_string (value);
#line 255 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 255 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp1_);
#line 255 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp1_);
#line 256 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = _geary_js_callable_ref0 (self);
#line 256 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp2_;
#line 256 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1732 "util-js.c"
}


GearyJSCallable*
geary_js_callable_int (GearyJSCallable* self,
                       gint value)
{
	GearyJSCallable* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyJSCallable* _tmp2_;
#line 259 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = g_strdup_printf ("%i", value);
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp1_);
#line 260 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (_tmp1_);
#line 261 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp2_ = _geary_js_callable_ref0 (self);
#line 261 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp2_;
#line 261 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1760 "util-js.c"
}


GearyJSCallable*
geary_js_callable_bool (GearyJSCallable* self,
                        gboolean value)
{
	GearyJSCallable* result = NULL;
	const gchar* _tmp0_ = NULL;
	GearyJSCallable* _tmp1_;
#line 264 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 265 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (value) {
#line 265 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp0_ = "true";
#line 1777 "util-js.c"
	} else {
#line 265 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		_tmp0_ = "false";
#line 1781 "util-js.c"
	}
#line 265 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp0_);
#line 266 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = _geary_js_callable_ref0 (self);
#line 266 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	result = _tmp1_;
#line 266 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return result;
#line 1791 "util-js.c"
}


static void
_vala_array_add23 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 270 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if ((*length) == (*size)) {
#line 270 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 270 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1807 "util-js.c"
	}
#line 270 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	(*array)[(*length)++] = value;
#line 270 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	(*array)[*length] = NULL;
#line 1813 "util-js.c"
}


static inline void
geary_js_callable_add_param (GearyJSCallable* self,
                             const gchar* value)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
#line 269 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_if_fail (GEARY_JS_IS_CALLABLE (self));
#line 269 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_if_fail (value != NULL);
#line 270 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = self->priv->safe_args;
#line 270 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0__length1 = self->priv->safe_args_length1;
#line 270 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp1_ = g_strdup (value);
#line 270 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_vala_array_add23 (&self->priv->safe_args, &self->priv->safe_args_length1, &self->priv->_safe_args_size_, _tmp1_);
#line 1836 "util-js.c"
}


static void
geary_js_value_callable_init (GValue* value)
{
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	value->data[0].v_pointer = NULL;
#line 1845 "util-js.c"
}


static void
geary_js_value_callable_free_value (GValue* value)
{
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (value->data[0].v_pointer) {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		geary_js_callable_unref (value->data[0].v_pointer);
#line 1856 "util-js.c"
	}
}


static void
geary_js_value_callable_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (src_value->data[0].v_pointer) {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		dest_value->data[0].v_pointer = geary_js_callable_ref (src_value->data[0].v_pointer);
#line 1869 "util-js.c"
	} else {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1873 "util-js.c"
	}
}


static gpointer
geary_js_value_callable_peek_pointer (const GValue* value)
{
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return value->data[0].v_pointer;
#line 1883 "util-js.c"
}


static gchar*
geary_js_value_callable_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (collect_values[0].v_pointer) {
#line 1895 "util-js.c"
		GearyJSCallable * object;
		object = collect_values[0].v_pointer;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		if (object->parent_instance.g_class == NULL) {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1902 "util-js.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1906 "util-js.c"
		}
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		value->data[0].v_pointer = geary_js_callable_ref (object);
#line 1910 "util-js.c"
	} else {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 1914 "util-js.c"
	}
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return NULL;
#line 1918 "util-js.c"
}


static gchar*
geary_js_value_callable_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	GearyJSCallable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (!object_p) {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1934 "util-js.c"
	}
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (!value->data[0].v_pointer) {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		*object_p = NULL;
#line 1940 "util-js.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		*object_p = value->data[0].v_pointer;
#line 1944 "util-js.c"
	} else {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		*object_p = geary_js_callable_ref (value->data[0].v_pointer);
#line 1948 "util-js.c"
	}
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return NULL;
#line 1952 "util-js.c"
}


GParamSpec*
geary_js_param_spec_callable (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	GearyJSParamSpecCallable* spec;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GEARY_JS_TYPE_CALLABLE), NULL);
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return G_PARAM_SPEC (spec);
#line 1972 "util-js.c"
}


gpointer
geary_js_value_get_callable (const GValue* value)
{
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE), NULL);
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return value->data[0].v_pointer;
#line 1983 "util-js.c"
}


void
geary_js_value_set_callable (GValue* value,
                             gpointer v_object)
{
	GearyJSCallable * old;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE));
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	old = value->data[0].v_pointer;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (v_object) {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_JS_TYPE_CALLABLE));
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		value->data[0].v_pointer = v_object;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		geary_js_callable_ref (value->data[0].v_pointer);
#line 2006 "util-js.c"
	} else {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 2010 "util-js.c"
	}
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (old) {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		geary_js_callable_unref (old);
#line 2016 "util-js.c"
	}
}


void
geary_js_value_take_callable (GValue* value,
                              gpointer v_object)
{
	GearyJSCallable * old;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE));
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	old = value->data[0].v_pointer;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (v_object) {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_JS_TYPE_CALLABLE));
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		value->data[0].v_pointer = v_object;
#line 2038 "util-js.c"
	} else {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 2042 "util-js.c"
	}
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (old) {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		geary_js_callable_unref (old);
#line 2048 "util-js.c"
	}
}


static void
geary_js_callable_class_init (GearyJSCallableClass * klass)
{
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	geary_js_callable_parent_class = g_type_class_peek_parent (klass);
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	((GearyJSCallableClass *) klass)->finalize = geary_js_callable_finalize;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_type_class_adjust_private_offset (klass, &GearyJSCallable_private_offset);
#line 2062 "util-js.c"
}


static void
geary_js_callable_instance_init (GearyJSCallable * self)
{
	gchar** _tmp0_;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->priv = geary_js_callable_get_instance_private (self);
#line 238 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 238 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->priv->safe_args = _tmp0_;
#line 238 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->priv->safe_args_length1 = 0;
#line 238 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->priv->_safe_args_size_ = self->priv->safe_args_length1;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->ref_count = 1;
#line 2082 "util-js.c"
}


static void
geary_js_callable_finalize (GearyJSCallable * obj)
{
	GearyJSCallable * self;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_JS_TYPE_CALLABLE, GearyJSCallable);
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_signal_handlers_destroy (self);
#line 237 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	_g_free0 (self->priv->base_name);
#line 238 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	self->priv->safe_args = (_vala_array_free (self->priv->safe_args, self->priv->safe_args_length1, (GDestroyNotify) g_free), NULL);
#line 2098 "util-js.c"
}


/**
     * A class for constructing a well formed, safe, invokable JS call.
     */
GType
geary_js_callable_get_type (void)
{
	static volatile gsize geary_js_callable_type_id__volatile = 0;
	if (g_once_init_enter (&geary_js_callable_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { geary_js_value_callable_init, geary_js_value_callable_free_value, geary_js_value_callable_copy_value, geary_js_value_callable_peek_pointer, "p", geary_js_value_callable_collect_value, "p", geary_js_value_callable_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GearyJSCallableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_js_callable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyJSCallable), 0, (GInstanceInitFunc) geary_js_callable_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType geary_js_callable_type_id;
		geary_js_callable_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GearyJSCallable", &g_define_type_info, &g_define_type_fundamental_info, 0);
		GearyJSCallable_private_offset = g_type_add_instance_private (geary_js_callable_type_id, sizeof (GearyJSCallablePrivate));
		g_once_init_leave (&geary_js_callable_type_id__volatile, geary_js_callable_type_id);
	}
	return geary_js_callable_type_id__volatile;
}


gpointer
geary_js_callable_ref (gpointer instance)
{
	GearyJSCallable * self;
	self = instance;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	g_atomic_int_inc (&self->ref_count);
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	return instance;
#line 2131 "util-js.c"
}


void
geary_js_callable_unref (gpointer instance)
{
	GearyJSCallable * self;
	self = instance;
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		GEARY_JS_CALLABLE_GET_CLASS (self)->finalize (self);
#line 235 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-js.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2146 "util-js.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



