/* util-string.c generated by valac 0.41.91, the Vala compiler
 * generated from util-string.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* GLib's character-based substring function.*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gchar* g_utf8_substring (const gchar* str,
                         glong start_pos,
                         glong end_pos);
#define GEARY_STRING_EOS '\0'
gboolean geary_string_is_empty_or_whitespace (const gchar* str);
gboolean geary_string_is_empty (const gchar* str);
gint geary_string_count_char (const gchar* s,
                              gunichar c);
gboolean geary_string_contains_any_char (const gchar* str,
                                         gunichar* chars,
                                         int chars_length1);
static gboolean _vala_unichar_array_contains (gunichar * stack,
                                       int stack_length,
                                       gunichar needle);
guint geary_string_stri_hash (const gchar* str);
gboolean geary_string_stri_equal (const gchar* a,
                                  const gchar* b);
gint geary_string_stri_cmp (const gchar* a,
                            const gchar* b);
gchar* geary_string_reduce_whitespace (const gchar* _s);
gchar* geary_string_safe_byte_substring (const gchar* s,
                                         gssize max_length);


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1162 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1162 "glib-2.0.vapi"
	result = _tmp0_;
#line 1162 "glib-2.0.vapi"
	return result;
#line 62 "util-string.c"
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1285 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1286 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1286 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1287 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1287 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1288 "glib-2.0.vapi"
	result = _result_;
#line 1288 "glib-2.0.vapi"
	return result;
#line 87 "util-string.c"
}


gboolean
geary_string_is_empty_or_whitespace (const gchar* str)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	if (str == NULL) {
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		_tmp1_ = TRUE;
#line 101 "util-string.c"
	} else {
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		_tmp1_ = string_get (str, (glong) 0) == GEARY_STRING_EOS;
#line 105 "util-string.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	if (_tmp1_) {
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		_tmp0_ = TRUE;
#line 111 "util-string.c"
	} else {
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		_tmp2_ = string_strip (str);
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		_tmp3_ = _tmp2_;
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		_tmp0_ = string_get (_tmp3_, (glong) 0) == GEARY_STRING_EOS;
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		_g_free0 (_tmp3_);
#line 123 "util-string.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	result = _tmp0_;
#line 16 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	return result;
#line 129 "util-string.c"
}


inline gboolean
geary_string_is_empty (const gchar* str)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 20 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	if (str == NULL) {
#line 20 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		_tmp0_ = TRUE;
#line 142 "util-string.c"
	} else {
#line 20 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		_tmp0_ = string_get (str, (glong) 0) == GEARY_STRING_EOS;
#line 146 "util-string.c"
	}
#line 20 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	result = _tmp0_;
#line 20 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	return result;
#line 152 "util-string.c"
}


static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1082 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1083 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1083 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1085 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1085 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 175 "util-string.c"
		gchar* _tmp2_;
#line 1086 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1086 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1086 "glib-2.0.vapi"
		return result;
#line 183 "util-string.c"
	} else {
#line 1088 "glib-2.0.vapi"
		result = -1;
#line 1088 "glib-2.0.vapi"
		return result;
#line 189 "util-string.c"
	}
}


gint
geary_string_count_char (const gchar* s,
                         gunichar c)
{
	gint result = 0;
	gint count = 0;
#line 23 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	g_return_val_if_fail (s != NULL, 0);
#line 24 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	count = 0;
#line 204 "util-string.c"
	{
		gint index = 0;
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		index = 0;
#line 209 "util-string.c"
		{
			gboolean _tmp0_ = FALSE;
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
			_tmp0_ = TRUE;
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
			while (TRUE) {
#line 216 "util-string.c"
				gint _tmp3_;
				gint _tmp4_;
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				if (!_tmp0_) {
#line 221 "util-string.c"
					gint _tmp1_;
					gint _tmp2_;
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp1_ = index;
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					index = _tmp1_ + 1;
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp2_ = count;
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					count = _tmp2_ + 1;
#line 232 "util-string.c"
				}
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				_tmp0_ = FALSE;
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				_tmp3_ = index;
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				index = string_index_of_char (s, c, _tmp3_);
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				_tmp4_ = index;
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				if (!(_tmp4_ >= 0)) {
#line 25 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					break;
#line 246 "util-string.c"
				}
			}
		}
	}
#line 27 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	result = count;
#line 27 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	return result;
#line 255 "util-string.c"
}


static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gunichar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1181 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1182 "glib-2.0.vapi"
	_tmp0_ = _vala_c;
#line 1182 "glib-2.0.vapi"
	if (_tmp0_ != ((gunichar) 0)) {
#line 275 "util-string.c"
		gchar* _tmp1_;
#line 1183 "glib-2.0.vapi"
		_tmp1_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1183 "glib-2.0.vapi"
		*index = (gint) (_tmp1_ - ((gchar*) self));
#line 1184 "glib-2.0.vapi"
		result = TRUE;
#line 1184 "glib-2.0.vapi"
		if (c) {
#line 1184 "glib-2.0.vapi"
			*c = _vala_c;
#line 287 "util-string.c"
		}
#line 1184 "glib-2.0.vapi"
		return result;
#line 291 "util-string.c"
	} else {
#line 1186 "glib-2.0.vapi"
		result = FALSE;
#line 1186 "glib-2.0.vapi"
		if (c) {
#line 1186 "glib-2.0.vapi"
			*c = _vala_c;
#line 299 "util-string.c"
		}
#line 1186 "glib-2.0.vapi"
		return result;
#line 303 "util-string.c"
	}
#line 1180 "glib-2.0.vapi"
	if (c) {
#line 1180 "glib-2.0.vapi"
		*c = _vala_c;
#line 309 "util-string.c"
	}
}


static gboolean
_vala_unichar_array_contains (gunichar * stack,
                              int stack_length,
                              gunichar needle)
{
	int i;
#line 34 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	for (i = 0; i < stack_length; i++) {
#line 34 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		if (needle == stack[i]) {
#line 34 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
			return TRUE;
#line 326 "util-string.c"
		}
	}
#line 34 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	return FALSE;
#line 331 "util-string.c"
}


gboolean
geary_string_contains_any_char (const gchar* str,
                                gunichar* chars,
                                int chars_length1)
{
	gboolean result = FALSE;
	gint index = 0;
	gunichar ch = 0U;
#line 30 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	g_return_val_if_fail (str != NULL, FALSE);
#line 31 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	index = 0;
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	while (TRUE) {
#line 349 "util-string.c"
		gunichar _tmp0_ = 0U;
		gboolean _tmp1_;
		gunichar _tmp2_;
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		_tmp1_ = string_get_next_char (str, &index, &_tmp0_);
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		ch = _tmp0_;
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		if (!_tmp1_) {
#line 33 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
			break;
#line 361 "util-string.c"
		}
#line 34 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		_tmp2_ = ch;
#line 34 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		if (_vala_unichar_array_contains (chars, chars_length1, _tmp2_)) {
#line 35 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
			result = TRUE;
#line 35 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
			return result;
#line 371 "util-string.c"
		}
	}
#line 38 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	result = FALSE;
#line 38 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	return result;
#line 378 "util-string.c"
}


guint
geary_string_stri_hash (const gchar* str)
{
	guint result = 0U;
	GHashFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint _tmp3_;
#line 41 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	g_return_val_if_fail (str != NULL, 0U);
#line 42 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp0_ = g_str_hash;
#line 42 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp1_ = g_utf8_strdown (str, (gssize) -1);
#line 42 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp2_ = _tmp1_;
#line 42 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp3_ = _tmp0_ (_tmp2_);
#line 42 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_g_free0 (_tmp2_);
#line 42 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	result = _tmp3_;
#line 42 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	return result;
#line 406 "util-string.c"
}


gboolean
geary_string_stri_equal (const gchar* a,
                         const gchar* b)
{
	gboolean result = FALSE;
	GEqualFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
#line 45 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 45 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp0_ = g_str_equal;
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp1_ = g_utf8_strdown (a, (gssize) -1);
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp2_ = _tmp1_;
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp3_ = g_utf8_strdown (b, (gssize) -1);
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp4_ = _tmp3_;
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp5_ = _tmp0_ (_tmp2_, _tmp4_);
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_g_free0 (_tmp4_);
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_g_free0 (_tmp2_);
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	result = _tmp5_;
#line 46 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	return result;
#line 445 "util-string.c"
}


gint
geary_string_stri_cmp (const gchar* a,
                       const gchar* b)
{
	gint result = 0;
	GCompareFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_;
#line 49 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 49 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 50 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp0_ = g_strcmp0;
#line 50 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp1_ = g_utf8_strdown (a, (gssize) -1);
#line 50 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp2_ = _tmp1_;
#line 50 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp3_ = g_utf8_strdown (b, (gssize) -1);
#line 50 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp4_ = _tmp3_;
#line 50 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp5_ = _tmp0_ (_tmp2_, _tmp4_);
#line 50 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_g_free0 (_tmp4_);
#line 50 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_g_free0 (_tmp2_);
#line 50 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	result = _tmp5_;
#line 50 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	return result;
#line 484 "util-string.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1458 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1458 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1458 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1459 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1459 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 507 "util-string.c"
	} else {
#line 1459 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 511 "util-string.c"
	}
#line 1459 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1459 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 517 "util-string.c"
	} else {
#line 1459 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 521 "util-string.c"
	}
#line 1459 "glib-2.0.vapi"
	if (_tmp0_) {
#line 525 "util-string.c"
		gchar* _tmp2_;
#line 1460 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1460 "glib-2.0.vapi"
		result = _tmp2_;
#line 1460 "glib-2.0.vapi"
		return result;
#line 533 "util-string.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1463 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1463 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1463 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
#line 1463 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1463 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1463 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1463 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1463 "glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 561 "util-string.c"
				goto __catch319_g_regex_error;
			}
#line 1463 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1463 "glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1463 "glib-2.0.vapi"
			return NULL;
#line 570 "util-string.c"
		}
#line 1464 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1464 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
#line 1464 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1464 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1464 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1464 "glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 584 "util-string.c"
				goto __catch319_g_regex_error;
			}
#line 1464 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1464 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1464 "glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1464 "glib-2.0.vapi"
			return NULL;
#line 595 "util-string.c"
		}
#line 1464 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1464 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1464 "glib-2.0.vapi"
		result = _tmp10_;
#line 1464 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1464 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1464 "glib-2.0.vapi"
		return result;
#line 609 "util-string.c"
	}
	goto __finally319;
	__catch319_g_regex_error:
	{
		GError* e = NULL;
#line 1462 "glib-2.0.vapi"
		e = _inner_error_;
#line 1462 "glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1466 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1462 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 623 "util-string.c"
	}
	__finally319:
#line 1462 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1462 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1462 "glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1462 "glib-2.0.vapi"
		return NULL;
#line 634 "util-string.c"
	}
}


static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1191 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1192 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1192 "glib-2.0.vapi"
	return result;
#line 650 "util-string.c"
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1407 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1407 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1407 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1408 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 676 "util-string.c"
		glong _tmp2_;
#line 1409 "glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1409 "glib-2.0.vapi"
		start = _tmp2_ + start;
#line 682 "util-string.c"
	}
#line 1411 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 686 "util-string.c"
		glong _tmp3_;
#line 1412 "glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1412 "glib-2.0.vapi"
		end = _tmp3_ + end;
#line 692 "util-string.c"
	}
#line 1414 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 696 "util-string.c"
		glong _tmp5_;
#line 1414 "glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1414 "glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 702 "util-string.c"
	} else {
#line 1414 "glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 706 "util-string.c"
	}
#line 1414 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1415 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 712 "util-string.c"
		glong _tmp7_;
#line 1415 "glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1415 "glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 718 "util-string.c"
	} else {
#line 1415 "glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 722 "util-string.c"
	}
#line 1415 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1416 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1417 "glib-2.0.vapi"
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1417 "glib-2.0.vapi"
	result = _tmp8_;
#line 1417 "glib-2.0.vapi"
	return result;
#line 734 "util-string.c"
}


gchar*
geary_string_reduce_whitespace (const gchar* _s)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 54 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	g_return_val_if_fail (_s != NULL, NULL);
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp0_ = g_strdup (_s);
#line 55 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	s = _tmp0_;
#line 56 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp1_ = s;
#line 56 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp2_ = string_replace (_tmp1_, "\n", " ");
#line 56 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_g_free0 (s);
#line 56 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	s = _tmp2_;
#line 57 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp3_ = s;
#line 57 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp4_ = string_replace (_tmp3_, "\r", " ");
#line 57 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_g_free0 (s);
#line 57 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	s = _tmp4_;
#line 58 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp5_ = s;
#line 58 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp6_ = string_replace (_tmp5_, "\t", " ");
#line 58 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_g_free0 (s);
#line 58 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	s = _tmp6_;
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp7_ = s;
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp8_ = string_strip (_tmp7_);
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_g_free0 (s);
#line 59 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	s = _tmp8_;
#line 790 "util-string.c"
	{
		gint i = 0;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		i = 1;
#line 795 "util-string.c"
		{
			gboolean _tmp9_ = FALSE;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
			_tmp9_ = TRUE;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
			while (TRUE) {
#line 802 "util-string.c"
				gint _tmp11_;
				const gchar* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gboolean _tmp15_ = FALSE;
				const gchar* _tmp16_;
				gint _tmp17_;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				if (!_tmp9_) {
#line 812 "util-string.c"
					gint _tmp10_;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp10_ = i;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					i = _tmp10_ + 1;
#line 818 "util-string.c"
				}
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				_tmp9_ = FALSE;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				_tmp11_ = i;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				_tmp12_ = s;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				_tmp13_ = strlen (_tmp12_);
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				_tmp14_ = _tmp13_;
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				if (!(_tmp11_ < _tmp14_)) {
#line 62 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					break;
#line 834 "util-string.c"
				}
#line 63 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				_tmp16_ = s;
#line 63 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				_tmp17_ = i;
#line 63 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				if (string_get_char (_tmp16_, (glong) _tmp17_) == ((gunichar) ' ')) {
#line 842 "util-string.c"
					const gchar* _tmp18_;
					gint _tmp19_;
#line 63 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp18_ = s;
#line 63 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp19_ = i;
#line 63 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp15_ = string_get_char (_tmp18_, (glong) (_tmp19_ - 1)) == ((gunichar) ' ');
#line 851 "util-string.c"
				} else {
#line 63 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp15_ = FALSE;
#line 855 "util-string.c"
				}
#line 63 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
				if (_tmp15_) {
#line 859 "util-string.c"
					const gchar* _tmp20_;
					gint _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					const gchar* _tmp24_;
					gint _tmp25_;
					const gchar* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gint _tmp32_;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp20_ = s;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp21_ = i;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp22_ = string_slice (_tmp20_, (glong) 0, (glong) (_tmp21_ - 1));
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp23_ = _tmp22_;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp24_ = s;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp25_ = i;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp26_ = s;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp27_ = strlen (_tmp26_);
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp28_ = _tmp27_;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp29_ = string_slice (_tmp24_, (glong) _tmp25_, (glong) _tmp28_);
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp30_ = _tmp29_;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp31_ = g_strconcat (_tmp23_, _tmp30_, NULL);
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_g_free0 (s);
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					s = _tmp31_;
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_g_free0 (_tmp30_);
#line 64 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_g_free0 (_tmp23_);
#line 65 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					_tmp32_ = i;
#line 65 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
					i = _tmp32_ - 1;
#line 909 "util-string.c"
				}
			}
		}
	}
#line 69 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	result = s;
#line 69 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	return result;
#line 918 "util-string.c"
}


gchar*
geary_string_safe_byte_substring (const gchar* s,
                                  gssize max_length)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp3_;
#line 76 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 77 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp0_ = strlen (s);
#line 77 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp1_ = _tmp0_;
#line 77 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	if (((gssize) _tmp1_) < max_length) {
#line 938 "util-string.c"
		gchar* _tmp2_;
#line 78 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		_tmp2_ = g_strdup (s);
#line 78 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		result = _tmp2_;
#line 78 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
		return result;
#line 946 "util-string.c"
	}
#line 80 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	_tmp3_ = g_utf8_substring (s, (glong) 0, (glong) g_utf8_strlen (s, max_length));
#line 80 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	result = _tmp3_;
#line 80 "/builddir/build/BUILD/geary-0.12.4/src/engine/util/util-string.vala"
	return result;
#line 954 "util-string.c"
}



